<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
class Expense extends Model
{
    use SoftDeletes;

    public function classOfAccount()
    {
        return $this->belongsTo(ClassOfAccount::class, 'class_of_account_id', 'id');
    }
    //
    /**
     * The table associated with the model.
     *
     * @var string
     */
    protected $table = 'expenses';

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'location_id',
        'transactions_password',
        'opening_balance',
        'debit_credit',
        'report_password',
        'date',
        'account_id',
        'account_name',
        'class_of_account_id',
        'show_user',
        'maintain_account',
        'description',
    ];


    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
    ];
}
