<?php

namespace App\Services;
use Illuminate\Http\Request;
use App\AccountMaster;
use App\AccountMastersAccountsDetail;
use App\ClassOfAccount;
use App\Currency;
use App\Http\Controllers\Controller;
use App\PurchaseInvoice;
use App\PurchaseReturnVoucher;
use App\SaleInvoice;
use App\SalesReturnVoucher;
use App\Services\Utils;
use Carbon\Carbon;
use PDF;
use Auth;
use App\Customer;
use App\Expense;
use App\Supplier;
use App\StaffAndSalesman;
use App\AdminOtherAccount;
use App\AdminSalesInvoice;
use App\AdminJournalVoucher;
use App\AdminReceiptVoucher;
use App\ReceiptVoucherExpense;
use App\PaymentVoucherExpense ;
use App\Company;
use App\DeliveryNote;
use App\CreditNote;
use App\DebitNote;
use App\OpeningBalance;
use App\PurchaseOrder;
use App\Quotation;
use App\WarehouseTransfer;
use App\AdminPurchaesInvoice;
use App\AdminPaymentVoucher;
use App\AdminTermsAndCondition;
use Illuminate\Support\Facades\DB;
use App\Services\CashReportService;
use App\Services\VatReportService;
use App\Services\DiscountReportService;

class TrialBalanceExpense
{
    public function TrialBalanceExpenses($request, $from_date, $to_date)
    {
        $from_date = $request->from_date;
        $to_date = $request->to_date;

        $classOfAccountId = 6;

        $ClassOfAccount = ClassOfAccount::find($classOfAccountId);

        $customers = Customer::where('branch_id', session()->get('selected_branch'))->where('class_of_account_id', $classOfAccountId)->get(['id', 'name_of_organisation as account_name','opening_balance','type','date']);
        $suppliers = Supplier::where('branch_id', session()->get('selected_branch'))->where('class_of_account_id', $classOfAccountId)->get(['id', 'name_of_organisation as account_name','opening_balance','type','date']);
        $expenses = Expense::where('branch_id', session()->get('selected_branch'))->where('class_of_account_id', $classOfAccountId)->get(['id', 'account_name','opening_balance','type','date']);
        $adminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))->where('class_of_account_id', $classOfAccountId)->get(['id', 'account_name','opening_balance','type','date']);
        $staffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))->where('class_of_account_id', $classOfAccountId)->get([
            'id',DB::raw("CONCAT(first_name, ' ', last_name) AS account_name"),'date_of_joining as date']);
        $allAccounts = $customers->concat($suppliers)->concat($expenses)->concat($adminOtherAccounts)->concat($staffAndSalesman);

        // dd($allAccounts);

        $totalDebit = [];
        $totalCredit = [];
        $obtotalDebit = [];
        $obtotalCredit = [];

        foreach ($allAccounts as $account) {
            $PurchaesInvoice = AdminPurchaesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $SaleInvoice = AdminSalesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $PaymentVoucherForCash = PaymentVoucherExpense::where(function($query) use ($account) {
                    $query->where('account_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();
            $PaymentVoucherForBank = PaymentVoucherExpense::where(function($query) use ($account) {
                    $query->where('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $ReceiptVoucherForBank = ReceiptVoucherExpense::where(function($query) use ($account) {
                    $query->where('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();
            $ReceiptVoucherForCash = ReceiptVoucherExpense::where(function($query) use ($account) {
                    $query->where('account_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $CreditNote = CreditNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $DebitNote = DebitNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $JournalVoucherForDebit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type', 'debit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $JournalVoucherForCredit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type', 'credit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

                // dd($JournalVoucherForDebit,$JournalVoucherForCredit);

            $TotalPurchaesInvoice = $PurchaesInvoice->sum('total_net_amount');
            $TotalDebitNote = $DebitNote->sum('total_net_amount');
            $TotalPaymentVoucherForCash = $PaymentVoucherForCash->sum('amount');
            $TotalPaymentVoucherForBank = $PaymentVoucherForBank->sum('amount');
            $TotalJournalVoucherForDebit = $JournalVoucherForDebit->sum('amount');

            $TotalSaleInvoice = $SaleInvoice->sum('total_net_amount');
            $TotalReceiptVoucherForBank = $ReceiptVoucherForBank->sum('amount');
            $TotalReceiptVoucherForCash = $ReceiptVoucherForCash->sum('amount');
            $TotalJournalVoucherForCredit = $JournalVoucherForCredit->sum('amount');
            $TotalCreditNote = $CreditNote->sum('total_net_amount');

            $totalDebitValue = $TotalSaleInvoice + $TotalPaymentVoucherForCash + $TotalDebitNote + $TotalJournalVoucherForDebit + $TotalReceiptVoucherForBank;

            $totalCreditValue = $TotalPurchaesInvoice + $TotalReceiptVoucherForCash + $TotalCreditNote + $TotalJournalVoucherForCredit + $TotalPaymentVoucherForBank;

            $totalDebit[] = [
                'account_name' => $account->account_name,
                'type' => $account->type,
                'opening_balance' => $account->opening_balance,
                'DebitBalance' => $totalDebitValue,
            ];

            // Check if the account type is 'Debit' and update 'DebitBalance' accordingly
            if (strtolower($account->type) === 'debit' && $account->date >= $from_date && $account->date <= $to_date) {
                $totalDebit[count($totalDebit) - 1]['DebitBalance'] +=  $account->opening_balance;
            }

            $totalCredit[] = [
                'account_name' => $account->account_name,
                'type' => $account->type,
                'opening_balance' => $account->opening_balance,
                'creditBalance' => $totalCreditValue,
            ];

            // Check if the account type is 'Credit' and update 'creditBalance' accordingly
            if (strtolower($account->type) === 'credit' && $account->date >= $from_date && $account->date <= $to_date) {
                $totalCredit[count($totalCredit) - 1]['creditBalance'] += $account->opening_balance;
            }


            }

            // dd($totalDebit,$totalCredit);


            $expenseTotalClosingBalance = [];

            foreach ($totalDebit as $debitItem) {
                foreach ($totalCredit as $creditItem) {
                    // Check if the account names match
                    if ($debitItem['account_name'] === $creditItem['account_name']) {
                        // Calculate the closing balance
                        $closingBalance = $debitItem['DebitBalance'] - $creditItem['creditBalance'];

                        // Store the closing balance with the account name if it's not 0
                        if ($closingBalance !== 0) {
                            $expenseTotalClosingBalance[$debitItem['account_name']] = $closingBalance;
                        }

                        // No need to continue the inner loop once the match is found
                        break;
                    }
                }
            }

            // dd($expenseTotalClosingBalance);

        return [$expenseTotalClosingBalance];



    }
    public function TrialBalanceExpensesForProfitAndLossLedgerReport($request, $from_date, $to_date)
    {
        $from_date = $request->from_date;
        $to_date = $request->to_date;

        $from_date = date("2003-01-01");
        $to_date = date('Y-m-d', strtotime('-1 day', strtotime($to_date)));

        $classOfAccountId = 6;

        $ClassOfAccount = ClassOfAccount::find($classOfAccountId);

        $customers = Customer::where('branch_id', session()->get('selected_branch'))->where('class_of_account_id', $classOfAccountId)->get(['id', 'name_of_organisation as account_name','opening_balance','type','date']);
        $suppliers = Supplier::where('branch_id', session()->get('selected_branch'))->where('class_of_account_id', $classOfAccountId)->get(['id', 'name_of_organisation as account_name','opening_balance','type','date']);
        $expenses = Expense::where('branch_id', session()->get('selected_branch'))->where('class_of_account_id', $classOfAccountId)->get(['id', 'account_name','opening_balance','type','date']);
        $adminOtherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))->where('class_of_account_id', $classOfAccountId)->get(['id', 'account_name','opening_balance','type','date']);
        $staffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))->where('class_of_account_id', $classOfAccountId)->get([
            'id',DB::raw("CONCAT(first_name, ' ', last_name) AS account_name"),'date_of_joining as date']);
        $allAccounts = $customers->concat($suppliers)->concat($expenses)->concat($adminOtherAccounts)->concat($staffAndSalesman);

        // dd($allAccounts);

        $totalDebit = [];
        $totalCredit = [];
        $obtotalDebit = [];
        $obtotalCredit = [];

        foreach ($allAccounts as $account) {
            $PurchaesInvoice = AdminPurchaesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $SaleInvoice = AdminSalesInvoice::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $PaymentVoucherForCash = PaymentVoucherExpense::where(function($query) use ($account) {
                    $query->where('account_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();
            $PaymentVoucherForBank = PaymentVoucherExpense::where(function($query) use ($account) {
                    $query->where('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $ReceiptVoucherForBank = ReceiptVoucherExpense::where(function($query) use ($account) {
                    $query->where('bank_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();
            $ReceiptVoucherForCash = ReceiptVoucherExpense::where(function($query) use ($account) {
                    $query->where('account_name', $account->account_name);
                })
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $CreditNote = CreditNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $DebitNote = DebitNote::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $JournalVoucherForDebit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type', 'debit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

            $JournalVoucherForCredit = AdminJournalVoucher::where('account_name', $account->account_name)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('type', 'credit')
                ->whereNull('deleted_at')
                ->groupBy('invoice_no')
                ->get();

                // dd($JournalVoucherForDebit,$JournalVoucherForCredit);

            $TotalPurchaesInvoice = $PurchaesInvoice->sum('total_net_amount');
            $TotalDebitNote = $DebitNote->sum('total_net_amount');
            $TotalPaymentVoucherForCash = $PaymentVoucherForCash->sum('amount');
            $TotalPaymentVoucherForBank = $PaymentVoucherForBank->sum('amount');
            $TotalJournalVoucherForDebit = $JournalVoucherForDebit->sum('amount');

            $TotalSaleInvoice = $SaleInvoice->sum('total_net_amount');
            $TotalReceiptVoucherForBank = $ReceiptVoucherForBank->sum('amount');
            $TotalReceiptVoucherForCash = $ReceiptVoucherForCash->sum('amount');
            $TotalJournalVoucherForCredit = $JournalVoucherForCredit->sum('amount');
            $TotalCreditNote = $CreditNote->sum('total_net_amount');

            $totalDebitValue = $TotalSaleInvoice + $TotalPaymentVoucherForCash + $TotalDebitNote + $TotalJournalVoucherForDebit + $TotalReceiptVoucherForBank;

            $totalCreditValue = $TotalPurchaesInvoice + $TotalReceiptVoucherForCash + $TotalCreditNote + $TotalJournalVoucherForCredit + $TotalPaymentVoucherForBank;

            $totalDebit[] = [
                'account_name' => $account->account_name,
                'type' => $account->type,
                'opening_balance' => $account->opening_balance,
                'DebitBalance' => $totalDebitValue,
            ];

            // Check if the account type is 'Debit' and update 'DebitBalance' accordingly
            if (strtolower($account->type) === 'debit' && $account->date >= $from_date && $account->date <= $to_date) {
                $totalDebit[count($totalDebit) - 1]['DebitBalance'] +=  $account->opening_balance;
            }

            $totalCredit[] = [
                'account_name' => $account->account_name,
                'type' => $account->type,
                'opening_balance' => $account->opening_balance,
                'creditBalance' => $totalCreditValue,
            ];

            // Check if the account type is 'Credit' and update 'creditBalance' accordingly
            if (strtolower($account->type) === 'credit' && $account->date >= $from_date && $account->date <= $to_date) {
                $totalCredit[count($totalCredit) - 1]['creditBalance'] += $account->opening_balance;
            }


            }

            // dd($totalDebit,$totalCredit);


            $expenseTotalClosingBalance = [];

            foreach ($totalDebit as $debitItem) {
                foreach ($totalCredit as $creditItem) {
                    // Check if the account names match
                    if ($debitItem['account_name'] === $creditItem['account_name']) {
                        // Calculate the closing balance
                        $closingBalance = $debitItem['DebitBalance'] - $creditItem['creditBalance'];

                        // Store the closing balance with the account name if it's not 0
                        if ($closingBalance !== 0) {
                            $expenseTotalClosingBalance[$debitItem['account_name']] = $closingBalance;
                        }

                        // No need to continue the inner loop once the match is found
                        break;
                    }
                }
            }

            // dd($expenseTotalClosingBalance);

        return [$expenseTotalClosingBalance];



    }

}
