@extends('layouts.crusher')
@section('content')





    <div class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-body">
                    <div class="row">
                        <div class="col-md-6">
                            <h6 class="card-title mb-4 titlcust">Edit Other Account Master</h6>
                        </div>
                    </div>
                    <form method="POST" action="{{ route('software.other_accounts.update', ['other_account'=>$otherAccount->id] ) }}" class="outer-repeater">

                    @csrf
                    @method('put')
                        <div class="row">



                            <div class="col-md-3">
                                <div class="form-group">
                                    <label>Account Opening Balance</label>
                                    @if (auth()->user()->role=='subadmin')
                                    <input class="form-control" value="{{ $otherAccount->opening_balance }}"
                                    placeholder="Account Opening Balance"
                                    id="example-password-input" disabled>
                                    @else
                                    <input class="form-control" type="text" name="opening_balance" value="{{ $otherAccount->opening_balance }}"
                                        placeholder="Account Opening Balance"
                                        id="example-password-input">
                                    @endif
                                </div>
                            </div>

                            <div class="col-md-3">
                                <div class="form-group">
                                    <label class="control-label">Debit/Credit</label>
                                    <select class="form-control select2" name="type">
                                        <option value="">Select Debit/Credit</option>
                                        <option value="debit" @if(isset($otherAccount) && $otherAccount->type == 'debit') selected @endif>Debit</option>
                                        <option value="credit" @if(isset($otherAccount) && $otherAccount->type == 'credit') selected @endif>Credit</option>
                                    </select>
                                </div>
                            </div>



                            <div class="col-md-6">
                                <div class="form-group">
                                    <label>Date</label>
                                    <input class="form-control" name="date" value="{{ $otherAccount->date }}" type="date" pattern="\d{4}-\d{2}-\d{2}">
                                </div>
                            </div>

                            <div class="col-md-6">
                                <div class="form-group">
                                    <label>Account Name</label>
                                    <input class="form-control" type="text" name="account_name" value="{{ $otherAccount->account_name }}"
                                        placeholder="Enter Account Name" id="example-text-input">
                                        @if ($errors->has('account_name'))
                                        <div class="text-danger">{{ $errors->first('account_name') }}</div>
                                        @endif
                                </div>
                            </div>

                            <div class="col-md-6">
                                <div class="form-group">
                                    <label class="control-label">Class Of Account</label>
                                    <select class="form-control select2" name="class_of_account_id">
                                        <option>Select Class of Account</option>
                                        @forelse ($classOfAccount as $account)
                                            <option value="{{ $account->id }}"
                                                @if (old('class_of_account_id', $otherAccount->class_of_account_id) == $account->id) selected @endif>
                                                {{ $account->name }}</option>
                                        @empty
                                        @endforelse
                                    </select>
                                    @if ($errors->has('class_of_account_id'))
                                    <div class="text-danger">{{ $errors->first('class_of_account_id') }}</div>
                                    @endif
                                </div>
                            </div>




                            <div class="col-md-12">
                                <div class="form-group">
                                    <label>Description</label>
                                    <textarea class="form-control" rows="4" type="text" name="description" placeholder="Enter Address"
                                        id="example-textarea-input">{{ $otherAccount->description }}</textarea>
                                </div>
                            </div>

                        </div>


                        <button class="btn btn-cust1 float-right" type="submit">Edit Other Account</button>



                    </form>

                </div>
            </div>
        </div>
    </div>
</div>
<!-- end row -->



    <div class="modal fade bs-example-modal-center1" tabindex="-1" role="dialog" aria-labelledby="mySmallModalLabel"
        aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-body">
                    <div class="col-md-12 text-center">
                        <div class="pt-4 pb-4">
                            <i class="fas fa-check checkp "></i>
                            <h4 class="card-title font-size-18">Successfully Recorded
                            </h4>
                        </div>
                    </div>
                </div>

            </div>
            <!-- /.modal-content -->
        </div>
        <!-- /.modal-dialog -->
    </div>
    <!-- /.modal -->


    <div class="modal fade bs-example-modal-center2" tabindex="-2" role="dialog" aria-labelledby="mySmallModalLabel"
        aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-body">
                    <div class="col-md-12 text-center">
                        <div class="pt-4 pb-4">
                            <i class="fas fa-times crossp "></i>
                            <h4 class="card-title font-size-18">Submission Failed
                            </h4>
                        </div>
                    </div>
                </div>

            </div>
            <!-- /.modal-content -->
        </div>
        <!-- /.modal-dialog -->
    </div>
    <!-- /.modal -->
@endsection
