@extends('layouts.crusher')
@section('content')

<div class="lds-dual-ring">
    <img class="loader-logo" src="{{ asset('assets/images/ledgematic-blue-logo.svg') }}" height="50" width="100"
        alt="Your Logo">
</div>


        <div class="row">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-body">
                        <div class="row">
                            <div class="col-md-6">
                                <h6 class="card-title mb-4 titlcust">Trial Balance
                                </h6>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-6">

                                <h6 class="">Date: <span>{{ date('d/m/Y', strtotime($to_date)) }}</span></h6>
                            </div>
                            <div class="col-md-6">
                                <div class="btn-group float-right" role="group" aria-label="Basic example">
                                    <a href="" type="button" class="btn btn-outline-primary"><i
                                            class="fas fa-mail-bulk"></i> Email (PDF Formate)</a>
                                    <a onclick="printPageArea('printableArea')" class="btn btn-outline-primary"> Print & PDF
                                        Formate</a>
                                </div>
                            </div>
                        </div>
                        <br>
                        <div id="printableArea" class="table-responsive mb-0" data-pattern="priority-columns">
                            <table class="table table-bordered dt-responsive nowrap"
                                style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                                <thead>
                                    <tr>
                                        <th>Particulars</th>
                                        <th>Debit</th>
                                        <th>Credit</th>
                                    </tr>
                                </thead>
                                <tbody>





<tr>
    <td>Capital Account</td>
    <td>
        @if ($CapitalAccountTotalDebit)
            <span> {{ number_format( $CapitalAccountTotalDebit, session('branch')->currency_decimal) }}</span>
        @endif
    </td>
    <td>
        @if ($CapitalAccountTotalCredit)
            <span>{{ number_format( $CapitalAccountTotalCredit, session('branch')->currency_decimal) }}</span>
        @endif
    </td>
</tr>
<tr class="td-drak-light">
    <td><strong>Capital Account</strong></td>
    <td>
        @if ($CapitalAccountTotalDebit)
            <span> {{ number_format( $CapitalAccountTotalDebit, session('branch')->currency_decimal) }}</span>
        @endif
    </td>
    <td>
        @if ($CapitalAccountTotalCredit)
            <span>{{ number_format( $CapitalAccountTotalCredit, session('branch')->currency_decimal) }}</span>
        @endif
    </td>
</tr>
<tr>
    <td>Loans</td>
    <td>
        @if ($loansTotalDebit)
        {{ number_format($loansTotalDebit, session('branch')->currency_decimal) }}
        @endif
    </td>
    <td>
        @if ($loansTotalCredit)
        {{ number_format($loansTotalCredit, session('branch')->currency_decimal) }}
        @endif
    </td>
</tr>
<tr class="td-drak-light">
    <td><strong>Loans</strong></td>
    <td>
        @if ($loansTotalDebit)
        {{ number_format($loansTotalDebit, session('branch')->currency_decimal) }}
        @endif
    </td>
    <td>
        @if ($loansTotalCredit)
        {{ number_format($loansTotalCredit, session('branch')->currency_decimal) }}
        @endif
    </td>
</tr>

<tr>
    <td>Current Liabilities</td>
    <td>{{ number_format($CurrentLiabilitiesTotalDebit, session('branch')->currency_decimal) }} </td>
    <td>{{ number_format(abs($CurrentLiabilitiesTotalCredit), session('branch')->currency_decimal) }}</td>
</tr>
<tr>
    <td>Sundry Creditors</td>
    <td>{{ number_format($SundryCreditorsTotalDebit, session('branch')->currency_decimal) }} </td>
    <td>{{ number_format(abs($SundryCreditorsTotalCredit), session('branch')->currency_decimal) }}</td>
</tr>
<tr>
    <td>Tax & Duties</td>
    <td>{{ number_format($debitVatReportCB, session('branch')->currency_decimal) }} </td>
    <td>{{ number_format(abs($creditVatReportCB), session('branch')->currency_decimal) }}</td>
</tr>

@php
    $currentLiabilitiesDebit = 0;
    $currentLiabilitiesCredit = 0;

    $currentLiabilitiesDebit = $CurrentLiabilitiesTotalDebit + $debitVatReportCB + $SundryCreditorsTotalDebit;
    $currentLiabilitiesCredit = $CurrentLiabilitiesTotalCredit + $creditVatReportCB + $SundryCreditorsTotalCredit;
@endphp
<tr class="td-drak-light">
    <td><strong>Current Liabilities</strong></td>
    <td>{{ number_format(abs($currentLiabilitiesDebit), session('branch')->currency_decimal) }}</td>
    <td>{{ number_format(abs($currentLiabilitiesCredit), session('branch')->currency_decimal) }}</td>
</tr>

@php
    $fixedTotalCB = 0;
@endphp
@foreach ($fixedTotalClosingBalance as $accountName => $closingBalance)
    <tr>
        <td>{{ $accountName }}</td>
        <td>{{ number_format(abs($closingBalance), session('branch')->currency_decimal) }}</td>
        <td></td>
    </tr>
    @php
        $fixedTotalCB += -$closingBalance;
    @endphp
@endforeach

@if ($fixedTotalCB)
    <tr class="td-drak-light">
        <td><strong>Fixed Assets</strong></td>
        <td><strong>{{ number_format(abs($fixedTotalCB), session('branch')->currency_decimal) }}</strong></td>
        <td></td>
    </tr>
@endif

@if ($allOpeningStock)
    <tr>
        <td>Opening Stock</td>
        <td>{{ number_format($allOpeningStock, session('branch')->currency_decimal) }}</td>
        <td></td>
    </tr>
@endif
@if ($AdvanceTotalDebit || $AdvanceTotalCredit)
    <tr>
        <td>Advance</td>
        <td>
            @if ($AdvanceTotalDebit)
                {{ number_format($AdvanceTotalDebit, session('branch')->currency_decimal) }}
            @endif
        </td>
        <td>
            @if ($AdvanceTotalCredit)
                {{ number_format($AdvanceTotalCredit, session('branch')->currency_decimal) }}
            @endif
        </td>
    </tr>
@endif

<tr>
    <td>Sundry Debtors</td>
    <td>{{ number_format($sundryDebtorsTotalDebit, session('branch')->currency_decimal) }}</td>
    <td>{{ number_format($sundryDebtorsTotalCredit, session('branch')->currency_decimal) }}</td>
</tr>
<tr>
    <td>Bank Accounts</td>
    <td>{{ number_format($bankAccountTotalDebit, session('branch')->currency_decimal) }}</td>
    <td>{{ number_format($bankAccountTotalCredit, session('branch')->currency_decimal) }}</td>
</tr>
<tr>
    <td>Cash in Hand</td>
    <td>
        @if ($debitCashReportCB)
            <span>{{ number_format($debitCashReportCB, session('branch')->currency_decimal) }}</span>
        @endif
    </td>
    <td>
        @if ($creditCashReportCB)
            <span>{{ number_format($creditCashReportCB, session('branch')->currency_decimal) }}</span>
        @endif
    </td>
</tr>

@php
    $currentAssetsDebit = 0;
    $currentAssetsCredit = 0;

    $currentAssetsDebit = $debitCashReportCB + $allOpeningStock + $AdvanceTotalDebit + $sundryDebtorsTotalDebit + $bankAccountTotalDebit;
    $currentAssetsCredit = $creditCashReportCB + $AdvanceTotalCredit + $sundryDebtorsTotalCredit + $bankAccountTotalCredit;
@endphp
<tr class="td-drak-light">
    <td><strong>Current Assets</strong></td>
    <td> {{ number_format($currentAssetsDebit, session('branch')->currency_decimal) }}</td>
    <td> {{ number_format($currentAssetsCredit, session('branch')->currency_decimal) }}</td>
</tr>
{{-- @if ($AdvanceTotalDebit > 0 && $AdvanceTotalCredit > 0)
    <tr>
        <td>Advance</td>
        <td>
            @if ($AdvanceTotalDebit > 0)
                {{ number_format($AdvanceTotalDebit, session('branch')->currency_decimal) }}
            @endif
        </td>
        <td>
            @if ($AdvanceTotalCredit > 0)
                {{ number_format($AdvanceTotalCredit, session('branch')->currency_decimal) }}
            @endif
        </td>
    </tr>
@endif

<tr>
    <td>Advance</td>
    <td>{{ number_format($AdvanceTotalDebit, session('branch')->currency_decimal) }}</td>
    <td>{{ number_format($AdvanceTotalCredit, session('branch')->currency_decimal) }}</td>
</tr>
<tr class="td-drak-light">
    <td><strong>Advance</strong></td>
    <td>{{ number_format($AdvanceTotalDebit, session('branch')->currency_decimal) }}</td>
    <td>{{ number_format($AdvanceTotalCredit, session('branch')->currency_decimal) }}</td>
</tr> --}}


@php
    $incomeTotalCB = 0;
@endphp
@foreach ($incomeTotalClosingBalance as $accountName => $closingBalance)
    <tr>
        <td>{{ $accountName }}</td>
        <td></td>
        <td>{{ number_format(abs($closingBalance), session('branch')->currency_decimal) }}</td>
    </tr>
    @php
        $incomeTotalCB += -$closingBalance;
    @endphp
@endforeach

@if ($incomeTotalCB)
    <tr class="td-drak-light">
        <td><strong><h6>Incomes</h6></strong></td>
        <td></td>
        <td><strong><h6>{{ number_format(abs($incomeTotalCB), session('branch')->currency_decimal) }}</h6></strong></td>
    </tr>
@endif

@if ($AllSaleTotalsDebit || $AllSaleTotalsCredit)

<tr>
    <td>Sales</td>
    <td>
        @if ($AllSaleTotalsDebit)
            <strong>{{ number_format(abs($AllSaleTotalsDebit), session('branch')->currency_decimal) }}</strong>
        @endif
    </td>
    <td>
        @if ($AllSaleTotalsCredit)
            <strong>{{ number_format(abs($AllSaleTotalsCredit), session('branch')->currency_decimal) }}</strong>
        @endif
    </td>
</tr>
<tr class="td-drak-light">
    <td><strong><h6>Sales Accounts</h6></strong></td>
    <td>
        @if ($AllSaleTotalsDebit)
            <strong>{{ number_format(abs($AllSaleTotalsDebit), session('branch')->currency_decimal) }}</strong>
        @endif
    </td>
    <td>
        @if ($AllSaleTotalsCredit)
            <strong>{{ number_format(abs($AllSaleTotalsCredit), session('branch')->currency_decimal) }}</strong>
        @endif
    </td>
</tr>
@endif
@if ($AllPurchaesTotals)
<tr>
    <td>Purchase</td>
    <td>
        <strong>{{ number_format($AllPurchaesTotals, session('branch')->currency_decimal) }}</strong>
    </td>
    <td>
    </td>
</tr>
<tr class="td-drak-light">
    <td><strong><h6>Purchase Accounts</h6></strong></td>
    <td>
        <strong>{{ number_format($AllPurchaesTotals, session('branch')->currency_decimal) }}</strong>
    </td>
    <td></td>
</tr>
@endif

{{-- @foreach ($mergedSalesExpenses->sortBy('account_name') as $mergedSalesExpense)
    @if ($mergedSalesExpense['total_expense_amount'])
        <tr>
            <td>{{ optional($mergedSalesExpense)['account_name']}}</td>
            <td>{{ number_format($mergedSalesExpense['total_expense_amount'], session('branch')->currency_decimal) }}</td>
            <td></td>
        </tr>
    @endif
    @php
        $totalMergedSalesExpense += $mergedSalesExpense['total_expense_amount'];
    @endphp
@endforeach

@foreach ($mergedPaymentExpenses->sortBy('account_name') as $mergedPaymentExpense)
    @if ($mergedPaymentExpense['amount'])
        <tr>
            <td>{{ optional($mergedPaymentExpense)['account_name']}}</td>
            <td>{{ number_format($mergedPaymentExpense['amount'], session('branch')->currency_decimal) }}</td>
            <td></td>
        </tr>
    @endif
    @php
        $totalMergedPaymentExpense += $mergedPaymentExpense['amount'];
    @endphp
@endforeach --}}

@php
    $expenseTotalCB = 0;
@endphp
@foreach ($expenseTotalClosingBalance as $accountName => $closingBalance)
    <tr>
        <td>{{ $accountName }}</td>
        <td>{{ number_format($closingBalance, session('branch')->currency_decimal) }}</td>
        <td></td>
    </tr>
    @php
        $expenseTotalCB += $closingBalance;
    @endphp
@endforeach

@if ($expenseTotalCB)
    <tr class="td-drak-light">
        <td><strong><h6>Expenses</h6></strong></td>
        <td><strong><h6>{{ number_format($expenseTotalCB, session('branch')->currency_decimal) }}</h6></strong></td>
        <td></td>
    </tr>
@endif

<?php
$DebitBalance = 0;
$CreditBalance = 0;

$grandTotalDebit = abs($fixedTotalCB) + $currentLiabilitiesDebit + $currentAssetsDebit + $AllSaleTotalsDebit + $AllPurchaesTotals + $expenseTotalCB + $CapitalAccountTotalDebit + $loansTotalDebit;

$grandTotalCredit = $CapitalAccountTotalCredit + $currentLiabilitiesCredit + $currentAssetsCredit + $incomeTotalCB + $AllSaleTotalsCredit + $loansTotalCredit;

// Calculate the balance differences
if ($grandTotalDebit > $grandTotalCredit) {
    $CreditBalance = $grandTotalDebit - $grandTotalCredit;
} elseif ($grandTotalCredit > $grandTotalDebit) {
    $DebitBalance = $grandTotalCredit - $grandTotalDebit;
}
?>

<tr>
    <td><strong>Profit & Loss A/C</strong></td>
    @if ($DebitBalance > 0)
        <td class="text-danger"><strong>{{ number_format($DebitBalance, session('branch')->currency_decimal) }}</strong></td>
        <td></td>
    @elseif ($CreditBalance > 0)
        <td></td>
        <td><strong>{{ number_format($CreditBalance, session('branch')->currency_decimal) }}</strong></td>
    @endif
</tr>
<tr class="td-drak-bg">
    <td><strong>Total</strong></td>
    <td><strong>{{ number_format($grandTotalDebit + $DebitBalance, session('branch')->currency_decimal) }}</strong></td>
    <td><strong>{{ number_format($grandTotalCredit + $CreditBalance, session('branch')->currency_decimal) }}</strong></td>
</tr>


                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- end row -->
    <script>
        function printPageArea(areaID) {
            var printContent = document.getElementById(areaID).innerHTML;
            var originalContent = document.body.innerHTML;
            document.body.innerHTML = printContent;
            window.print();
            document.body.innerHTML = originalContent;
        }
    </script>
@endsection

