@extends('layouts.crusher')
@section('content')


        <div class="row">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-body">
                        <div class="row">
                            <div class="col-md-6">
                                <h6 class="card-title mb-4 titlcust">Purchase Order</h6>
                            </div>

                        </div>
                        <!-- <div class="col-4"> -->
                        <form action="{{ route('software.purchase_orders.store') }}" method="POST" class="outer-repeater">

                            @csrf
                            <div class="row">

                                <div class="col-md-3">
                                    <div class="form-group">
                                        <label>Purchase Order #</label>
                                        <input class="form-control" type="text" readonly placeholder=""
                                            id="example-password-input" name="invoice_no"
                                            value="{{ old('invoice_no', $newPon) }}">
                                    </div>
                                </div>

                                <div class="col-md-6">

                                </div>

                                <div class="col-md-3">
                                    <div class="form-group">
                                        <label>Date</label>
                                        <input class="form-control PeriodClosingDate" name="date" type="date"
                                            value="{{ date('Y-m-d') }}" pattern="\d{4}-\d{2}-\d{2}">
                                    </div>
                                </div>
                            </div>


                            <div class="row">
                                <div class="col-md-12">
                                    <div class="form-group">
                                        <label for="account">Account Name:</label>
                                        <select id="account" class="form-control select2" name="account_id" >
                                            <option value="" selected disabled>Select Account</option>

                                            {{-- Loop through the merged $accounts collection --}}
                                            @forelse ($accounts as $account)
                                                <option value="{{ $account->id }}"
                                                    {{ old('account_id') == $account->id ? 'selected' : '' }}
                                                    data-account-type="{{ $account->table_name }}" data-account-name="{{ $account->account_name }}" data-acc-no="{{ $account->account_no }}">
                                                    {{ $account->account_name }}

                                                </option>
                                            @empty
                                                <option value="" selected disabled>No accounts available</option>
                                            @endforelse
                                        </select>
                                        <input type="hidden" name="account_type" id="account_type">
                                        <input type="hidden" name="account_name" class="account_name" id="account_name">
                                        <input type="hidden" class="acc_no" name="acc_no" id="acc_no">

                                        @error('account_id')
                                            <div class="text-danger">{{ $message }}</div>
                                        @enderror
                                    </div>
                                </div>

                                <div class="table-responsive mb-0" data-pattern="priority-columns">
                                    <table class="table table-bordered dt-responsive nowrap"
                                        style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                                        <thead>
                                            <tr>
                                                <th>Item Description</th>
                                                <th>Quantity</th>
                                                <th>Rate / Unit</th>
                                                <th>Gross Amount</th>
                                                <th>VAT %</th>
                                                <th>VAT Amount</th>
                                                <th>Net Amount</th>
                                                <th>Delete</th>
                                            </tr>
                                        </thead>

                                        <tbody id="table-body">
                                            <tr>
                                                <div class="inner-repeater mb-12">
                                                    <div data-repeater-list="inner-group" class="inner form-group">

                                                        <td>
                                                            <div class="form-group">
                                                                <textarea class="form-control" rows="1" type="text" placeholder="Item Description" id="example-textarea-input"
                                                                    name="item_description[]">
                                                                </textarea>
                                                            </div>
                                                        </td>

                                                        <td>
                                                            <div class="form-group">
                                                                <input class="form-control quantity" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');"
                                                                    placeholder="Quantity" id="quantity" name="quantity[]">
                                                            </div>
                                                        </td>
                                                        <td>
                                                            <div class="form-group">
                                                                <input class="form-control rate_unit" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');"
                                                                    placeholder="Rate/Unit" id="rate_unit"
                                                                    name="rate_unit[]">
                                                            </div>
                                                        </td>

                                                    </div>

                                                </div>

                                                <td>
                                                    <div class="form-group">
                                                        <input class="form-control gross_amount" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');"
                                                            placeholder="Gross Amount" id="gross_amount"
                                                            name="gross_amount[]">
                                                    </div>
                                                </td>
                                                <td>
                                                    <div class="form-group">
                                                        <input class="form-control vat_percentage" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');"
                                                            placeholder="VAT %" id="vat_percentage" name="vat_percentage[]">
                                                    </div>
                                                </td>
                                                <td>
                                                    <div class="form-group">
                                                        <input class="form-control vat_amount" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');"
                                                            placeholder="VAT Amount" id="vat_amount" name="vat_amount[]">
                                                    </div>
                                                </td>
                                                <td>
                                                    <div class="form-group">
                                                        <p><input type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');" class="form-control net_amount"
                                                                id="net_amount" name="net_amount[]" readonly></p>
                                                    </div>
                                                </td>

                                                <td>
                                                    <a href="" class="delete-row-btn"> <i
                                                            class="fas fa-trash-alt inner"></i></a>
                                                </td>


                                            </tr>

                                        </tbody>
                                    </table>
                                </div>
                            </div>

                            <div class="row">
                                <div class="col-md-8">
                                    <button id="add-more-btn" class="btn btn-outline-primary" type="button">Add
                                        more</button>
                                </div>
                                <div class="col-md-4">
                                    <!-- <h5>QTY Total: 0</h5> -->
                                </div>
                            </div>
                            <br>





                            <br>

                            <div class="row">
                                <div class="col-md-8">
                                </div>
                                <div class="col-md-4">
                                    <strong>
                                        <label>Total Quantity : </label>
                                        <span><input type="text" class="custin" id="total_quantity"
                                                name="total_quantity" readonly></span>
                                    </strong>
                                </div>
                                <div class="col-md-8">
                                </div>
                                <div class="col-md-4">
                                    <strong>
                                        <label>Total Gross Amount  : </label>
                                        <span><input type="text" class="custin" id="total_gross_amount"
                                                name="total_gross_amount" readonly></span>
                                    </strong>
                                </div>
                                <div class="col-md-8">
                                </div>
                                <div class="col-md-4">
                                    <strong>
                                        <label>Total Vat amount : </label>
                                        <span><input type="text" class="custin" id="total_vat_amount"
                                                name="total_vat_amount" readonly></span>
                                    </strong>
                                </div>
                                <div class="col-md-8">
                                </div>
                                <div class="col-md-4">
                                    <!-- <form class="repeater" enctype="multipart/form-data">
                                                                                    <div data-repeater-list="group-a">
                                                                                        <div data-repeater-item class="row">
                                                                                        </div>
                                                                                </form> -->


                                </div>

                                <div class="col-md-8">
                                </div>
                                <br>
                                <div class="col-md-4">
                                    <strong>
                                        <label>Total net amount </label>
                                        <span><input type="text" class="custin" id="total_net_amount"
                                                name="total_net_amount" readonly></span>
                                    </strong>
                                </div>
                                {{-- <div class="col-md-4">
                                    <strong>
                                        <label>Amount in Words : </label>
                                        <span><input type="text" class="custin" value=" "
                                                id="total_net_amount_words" name="amount_in_words" readonly
                                                style="overflow:visible;"></span>
                                    </strong>
                                </div> --}}
                                <div class="col-md-6">
                                    <div class="row">
                                        <div class="col-4">
                                            <strong>
                                                <label for="total_net_amount_words">Amount in Words :</label>
                                            </strong>
                                        </div>
                                        <div class="col-8">
                                            <input type="text" class="custin" id="total_net_amount_words" name="AmountInWords" readonly style="width: 120%;margin-left: -3.5rem;">
                                        </div>
                                    </div>
                                </div>
                                <div class="col-md-12">
                                    <div class="form-group">
                                        <label>Term & Conditions</label>
                                        <p>{{ $tnc->description ?? '' }}</p>
                                    </div>
                                </div>


                            </div>

                            <!-- Modal for Buyer Information -->

                            <div id="modal1" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="buyerModalLabel" aria-hidden="true">
                                <div class="modal-dialog">
                                    <div class="modal-content">
                                        <div class="modal-header">
                                            <h5 class="modal-title" id="buyerModalLabel">Buyer Information:</h5>
                                            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                                <span aria-hidden="true">&times;</span>
                                            </button>
                                        </div>
                                        <div class="modal-body">
                                            <div class="col-md-12">
                                                <div class="form-group">
                                                    <label>Name :</label>
                                                    <input class="form-control" type="text" placeholder="Enter Name"
                                                        id="example-password-input" name="name" id="name">
                                                </div>
                                            </div>
                                            <div class="col-md-12">
                                                <div class="form-group">
                                                    <label>Phone # :</label>
                                                    <input class="form-control" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');" placeholder="Enter Phone #"
                                                        id="example-password-input" name="phone" id="phone">
                                                </div>
                                            </div>
                                            <div class="col-md-12">
                                                <div class="form-group">
                                                    <label>Email :</label>
                                                    <input class="form-control" type="text" placeholder="Enter Email"
                                                        id="example-password-input" name="email" id="email">
                                                </div>
                                            </div>
                                            <div class="col-md-12">
                                                <div class="form-group">
                                                    <label>Vat Number :</label>
                                                    <input class="form-control" type="text" placeholder="Vat Number"
                                                        id="example-password-input" name="vat_number" name="vat_number">
                                                </div>
                                            </div>
                                            <div class="col-md-12">
                                                <div class="form-group">
                                                    <label>Address :</label>
                                                    <textarea class="form-control" rows="3" type="text" placeholder="Enter Address"
                                                        id="example-textarea-input" name="address" id="address">
                                            </textarea>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="modal-footer">
                                            <input type="hidden" name="invoice_no" value="{{ $newPon }}" id="invoice_no">
                                            <input type="hidden" name="type" value="purchase_order" id="type">
                                            <button type="button" class="btn btn-secondary waves-effect" data-dismiss="modal">Close</button>
                                            <button type="button" class="btn btn-primary waves-effect waves-light">Save</button>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <!-- /.modal-dialog -->


                            <button class="btn btn-cust1 float-right" type="submit">Create Purchase Invoice</button>



                        </form>


                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- end row -->


   {{-- <!-- Modals -->
   <div id="modal1" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="myModalLabel"
   aria-hidden="true">
   <div class="modal-dialog">
       <form action="" id="buyer-form">
       @csrf
       <div class="modal-content">
           <div class="modal-header">
               <h5 class="modal-title mt-0" id="myModalLabel">Buyer Information :</h5>
               <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                   <span aria-hidden="true">&times;</span>
               </button>
           </div>
           <div class="modal-body">
               <div class="col-md-12">
                   <div class="form-group">
                       <label>Name :</label>
                       <input class="form-control" type="text" placeholder="Enter Name"
                           id="example-password-input" name="name" id="name">
                   </div>
               </div>
               <div class="col-md-12">
                   <div class="form-group">
                       <label>Phone # :</label>
                       <input class="form-control" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');" placeholder="Enter Phone #"
                           id="example-password-input" name="phone" id="phone">
                   </div>
               </div>
               <div class="col-md-12">
                   <div class="form-group">
                       <label>Email :</label>
                       <input class="form-control" type="text" placeholder="Enter Email"
                           id="example-password-input" name="email" id="email">
                   </div>
               </div>
               <div class="col-md-12">
                   <div class="form-group">
                       <label>Vat Number :</label>
                       <input class="form-control" type="text" placeholder="Vat Number"
                           id="example-password-input" name="vat_number" name="vat_number">
                   </div>
               </div>
               <div class="col-md-12">
                   <div class="form-group">
                       <label>Address :</label>
                       <textarea class="form-control" rows="3" type="text" placeholder="Enter Address"
                           id="example-textarea-input" name="address" id="address">
               </textarea>
                   </div>
               </div>
           </div>
           <div class="modal-footer">
               <input type="hidden" name="invoice_no" value="{{ $newPon }}" id="invoice_no">
               <input type="hidden" name="type" value="purchase_order" id="type">
               <button type="button" class="btn btn-secondary waves-effect" data-dismiss="modal">Close</button>
               <button type="submit" class="btn btn-primary waves-effect waves-light">Save</button>
           </div>
       </div>
       </form>


       <!-- /.modal-content -->
   </div>
   <!-- /.modal-dialog -->
</div>
<!-- /.modal --> --}}

    <script>
        // function numberToWords(number) {
        //     var words = [
        //         'Zero', 'One', 'Two', 'Three', 'Four', 'Five', 'Six', 'Seven', 'Eight', 'Nine', 'Ten',
        //         'Eleven', 'Twelve', 'Thirteen', 'Fourteen', 'Fifteen', 'Sixteen', 'Seventeen', 'Eighteen', 'Nineteen'
        //     ];
        //     var tens = ['', '', 'Twenty', 'Thirty', 'Forty', 'Fifty', 'Sixty', 'Seventy', 'Eighty', 'Ninety'];
        //     var decimals = ['Tenth', 'Hundredth'];

        //     // Convert the whole number part to words
        //     function convertWholeNumber(num) {
        //         if (num < 20) {
        //             return words[num];
        //         } else if (num < 100) {
        //             return tens[Math.floor(num / 10)] + (num % 10 !== 0 ? ' ' + words[num % 10] : '');
        //         } else {
        //             return 'Number too large';
        //         }
        //     }

        //     var wholePart = Math.floor(number);
        //     var fractionalPart = Math.round((number - wholePart) * 100);

        //     var result = convertWholeNumber(wholePart);

        //     if (fractionalPart > 0) {
        //         result += ' and ' + convertWholeNumber(fractionalPart) + ' ' + decimals[Math.floor(Math.log10(fractionalPart))] + (fractionalPart > 1 ? 's' : '');
        //     }

        //     return result;
        // }
        //
    </script>
    <script src="https://code.jquery.com/jquery-3.7.0.js" integrity="sha256-JlqSTELeR4TLqP0OG9dxM7yDPqX1ox/HfgiSLBj8+kM="
        crossorigin="anonymous"></script>

        <script>
             // BUYER MODAL WORK START

        // Function to open the modal based on selected value
        // Function to open the modal based on selected value
        function openAccountModal(selectElement) {
            var selectedOption = selectElement.options[selectElement.selectedIndex];
            var accountName = selectedOption.textContent.trim(); // Trim to remove leading/trailing whitespaces

            // Check if the accountName is "Cash"
            if (accountName.toLowerCase() === "cash") {
                // Open the modal with ID 'modal1'
                $('#modal1').modal('show');
            } else {
                // For other options, you can perform additional actions if needed
                // Currently, there are no actions specified for other options
            }
        }

        // BUYER MODAL WORK END

        </script>
    <script>
        // Function to open the modal and set values
        function openAndSetValues() {
            // Replace the placeholder values with actual values
            var values = {
                name: 'John Doe',
                phone: '123456789',
                email: 'john@example.com',
                vat_number: 'VAT123',
                address: '123 Main Street'
            };

            // Set the values in the modal
            $('#name').val(values.name);
            $('#phone').val(values.phone);
            $('#email').val(values.email);
            $('#vat_number').val(values.vat_number);
            $('#address').val(values.address);

            // Open the modal
            $('#modal1').modal('show');
        }

        // Function to clear values when the modal is closed
        function clearValues() {
            $('#name').val('');
            $('#phone').val('');
            $('#email').val('');
            $('#vat_number').val('');
            $('#address').val('');
        }

        // Save button click event
        $('#modal1').on('click', '.btn-primary', function() {
            // Process the saved values here if needed
            // ...

            // Close the modal
            $('#modal1').modal('hide');
        });

        // Attach event handlers
        $('#modal1').on('show.bs.modal', openAndSetValues);
        $('#modal1').on('hidden.bs.modal', clearValues);
    </script>
    <script>
        $(document).ready(function() {

            // function calculateRow(row) {
            //     var quantity = parseFloat(row.find('.quantity').val()) || 0;
            //     var rateUnit = parseFloat(row.find('.rate_unit').val()) || 0;
            //     var vatPercentage = parseFloat(row.find('.vat_percentage').val()) || 0;

            //     var grossAmount = quantity * rateUnit;
            //     var vatAmount = grossAmount * (vatPercentage / 100);
            //     var netAmount = grossAmount + vatAmount;

            //     row.find('.gross_amount').val(grossAmount.toFixed({{session()->get('branch')->currency_decimal}}));
            //     row.find('.vat_amount').val(vatAmount.toFixed({{session()->get('branch')->currency_decimal}}));
            //     row.find('.net_amount').val(netAmount.toFixed({{session()->get('branch')->currency_decimal}}));
            // }

            function calculateRow(row) {
            var quantity = parseFloat(row.find('.quantity').val()) || 0;
            var rateUnit = parseFloat(row.find('.rate_unit').val()) || 0;
            var grossAmount = parseFloat(row.find('.gross_amount').val()) || 0;
            var vatPercentage = parseFloat(row.find('.vat_percentage').val()) || 0;

            // Calculate rateUnit if not provided, but quantity and grossAmount are provided
            if (quantity !== 0 && grossAmount !== 0) {
                rateUnit = rateUnit || (grossAmount / quantity);
            }

            // Calculate grossAmount if rateUnit is provided
            if (rateUnit !== 0 && quantity !== 0) {
                grossAmount = quantity * rateUnit;
            }

            var vatAmount = grossAmount * (vatPercentage / 100);
            var netAmount = grossAmount + vatAmount;

            // Update the input fields with the calculated values
            row.find('.rate_unit').val(rateUnit); // Assuming 2 decimal places for simplicity
            row.find('.gross_amount').val(grossAmount.toFixed(2));
            row.find('.vat_amount').val(vatAmount.toFixed(2));
            row.find('.net_amount').val(netAmount.toFixed(2));
        }

            // Calculate for existing rows (initial row and dynamically generated rows)
            $('#table-body tr').each(function() {
                calculateRow($(this));
            });

            // Event delegation for dynamically added rows
            $('#table-body').on('input', '.quantity, .rate_unit, .vat_percentage', function() {
                calculateRow($(this).closest('tr'));
                calculateTotalQuantity();
                calculateTotalGross();
                calculateTotalVatAmount();
                calculateTotalNetAmount();
                // convertTotalNetAmountToWords();
            });

            // Event listener for changes in sub_account_amount
            $('.sub_account_amount').on('input', function() {
                calculateTotalNetAmount();
            });

            $('#add-more-btn').on('click', function() {
                var newRow = `
            <tr>
                <td>
                    <div class="form-group">
                        <textarea class="form-control item_desc" rows="1" type="text" placeholder="Item Description" name="item_description[]"></textarea>
                    </div>
                </td>
                <td>
                    <div class="form-group">
                        <input class="form-control quantity" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');" placeholder="Quantity" name="quantity[]">
                    </div>
                </td>
                <td>
                    <div class="form-group">
                        <input class="form-control rate_unit" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');" placeholder="Rate/Unit" name="rate_unit[]">
                    </div>
                </td>
                <td>
                    <div class="form-group">
                        <input class="form-control gross_amount" type="text" placeholder="Gross Amount" name="gross_amount[]" readonly>
                    </div>
                </td>
                <td>
                    <div class="form-group">
                        <input class="form-control vat_percentage" type="text" placeholder="VAT %" name="vat_percentage[]">
                    </div>
                </td>
                <td>
                    <div class="form-group">
                        <input class="form-control vat_amount" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');" placeholder="VAT Amount" name="vat_amount[]" readonly>
                    </div>
                </td>
                <td>
                    <div class="form-group">
                        <input class="form-control net_amount form-control" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');" placeholder="Net Amount" name="net_amount[]" readonly>
                    </div>
                </td>
                <td>
                    <a href="#" class="delete-row-btn"><i class="fas fa-trash-alt"></i></a>
                </td>
            </tr>
        `;

                $('#table-body').append(newRow);

                // Initialize calculation for the new row
                calculateRow($('#table-body tr:last'));
                calculateTotalQuantity();
                calculateTotalGross();
                calculateTotalVatAmount();
                calculateTotalNetAmount();
                // convertTotalNetAmountToWords();
            });

            // Event delegation for delete button
            $('#table-body').on('click', '.delete-row-btn', function() {
                $(this).closest('tr').remove();
                calculateTotalQuantity();
                calculateTotalGross();
                calculateTotalVatAmount();
                calculateTotalNetAmount();
                // convertTotalNetAmountToWords();
            });

            // Calculate and update total quantity
            function calculateTotalQuantity() {
                var totalQuantity = 0;
                $('.quantity').each(function() {
                    totalQuantity += parseFloat($(this).val()) || 0;
                });
                $('#total_quantity').val(totalQuantity);
            }
            // Calculate and update total gross amount
            function calculateTotalGross() {
                var totalGross = 0;
                $('.gross_amount').each(function() {
                    totalGross += parseFloat($(this).val()) || 0;
                });
                $('#total_gross_amount').val(totalGross.toFixed({{session()->get('branch')->currency_decimal}}));
            }
            // Calculate and update total VAT amount
            function calculateTotalVatAmount() {
                var totalVatAmount = 0;
                $('.vat_amount').each(function() {
                    totalVatAmount += parseFloat($(this).val()) || 0;
                });
                $('#total_vat_amount').val(totalVatAmount.toFixed({{session()->get('branch')->currency_decimal}}));
            }
            // Calculate and update total net amount
            function calculateTotalNetAmount() {
                var totalNetAmount = parseFloat($('.sub_account_amount').val()) || 0;
                $('.net_amount').each(function() {
                    totalNetAmount += parseFloat($(this).val()) || 0;
                });
                $('#total_net_amount').val(totalNetAmount.toFixed({{session()->get('branch')->currency_decimal}}));

                // Convert total net amount to words and update the corresponding field
                var totalNetAmountWords = numberToWords(totalNetAmount);
                $('#total_net_amount_words').val(totalNetAmountWords);
            }
            // Convert total net amount to words
            // function convertTotalNetAmountToWords() {
            //     var totalNetAmount = parseFloat($('#total_net_amount').val()) || 0;
            //     var totalNetAmountWords = numberToWords(totalNetAmount);
            //     $('#total_net_amount_words').val(totalNetAmountWords);
            // }

            // Initial calculation for total quantity and total gross
            calculateTotalQuantity();
            calculateTotalGross();
            calculateTotalVatAmount();
            calculateTotalNetAmount();
            // convertTotalNetAmountToWords();
        });
    </script>

    <script>
        $(document).ready(function() {
            // Event handler for the add-clone-btn click
            $(document).on('click', '.add-clone-btn', function(e) {
                e.preventDefault();

                // Get the parent <tr> element
                var parentTr = $(this).closest('tr');

                // Clone the parent <tr> element
                var clonedTr = parentTr.clone();

                // Append the cloned <tr> after the parent <tr>
                parentTr.after(clonedTr);
            });
        });

        $(document).ready(function() {
            // $('#add-more-btn').click(function (e) {
            //     e.preventDefault();

            //     // Clone the existing row
            //     var newRow = $('#table-body tr').first().clone();

            //     // Clear input fields and select values in the cloned row
            //     newRow.find('input, textarea').val('');
            //     newRow.find('select').prop('selectedIndex', 0);

            //     // Append the cloned row to the table
            //     $('#table-body').append(newRow);
            // });

            $('#add-clone-btn').click(function(e) {
                e.preventDefault();

                // Clone the existing row
                var newRow = $('#table-body tr').first().clone();

                // Clear input fields and select values in the cloned row
                newRow.find('input, textarea').val('');
                newRow.find('select').prop('selectedIndex', 0);

                // Append the cloned row to the table
                $('#table-body').append(newRow);
            });

            // Handle delete button click event
            $(document).on('click', '.delete-row-btn', function(e) {
                e.preventDefault();

                // Get the parent row and remove it
                var row = $(this).closest('tr');
                row.remove();
            });
        });
    </script>


    <!-- modal script -->

    {{-- <script>
        document.getElementById("modalSelect").addEventListener("change", function() {
            var selectedModal = this.value;

            // Close any open modals
            $('.modal').modal('hide');

            // Open the selected modal
            $('#' + selectedModal).modal('show');
        });
    </script> --}}

    <script>
        // JavaScript to update the hidden input field when the dropdown selection changes
        $(document).ready(function() {
            function updateAccountType() {
                var selectedOption = $('#account option:selected');
                var accountType = selectedOption.data('account-type');
                var accountName = selectedOption.data('account-name');
                var accNo = selectedOption.data('acc-no');

                $('#account_type').val(accountType);
                $('.account_name').val(accountName);
                $('.acc_no').val(accNo);

            }

            // Run the function once when the page is ready
            updateAccountType();

            // Add an event listener to update the hidden input when the selection changes
            $('#account').change(updateAccountType);
        });
    </script>

@php
    use App\Branches;
    use Carbon\Carbon;

    $selectedBranchId = session('selected_branch');

    $branch = Branches::where('id', $selectedBranchId)->first();
@endphp

<script>
    @if (!empty($selectedBranchId))
        document.addEventListener("DOMContentLoaded", function() {
            var periodClosings = <?php echo json_encode($periodClosings); ?>;

            function isBeforePeriodClosing(date) {
                var selectedDate = new Date(date);
                for (var i = 0; i < periodClosings.length; i++) {
                    var closingDate = new Date(periodClosings[i]);
                    if (selectedDate < closingDate) {
                        return true;
                    }
                }
                return false;
            }

            function setColor(dateInput) {
                var selectedDate = dateInput.value;
                if (isBeforePeriodClosing(selectedDate)) {
                    dateInput.style.backgroundColor = 'lightgrey';
                } else {
                    dateInput.style.backgroundColor = '';
                }
            }

            var periodClosingDateInputs = document.querySelectorAll('.PeriodClosingDate');
            periodClosingDateInputs.forEach(function(input) {
                input.addEventListener('change', function() {
                    setColor(this);
                    if (isBeforePeriodClosing(this.value)) {
                        @if (!Branches::hasBranchPermission($selectedBranchId, 'Back Dated Entry As Per User Credentials'))
                            window.alert("Do you want to enter a closing period? Please contact admin.");
                            this.value = '';
                        @else
                            window.alert("Do you want to enter a closing period?");
                        @endif
                    }
                });
                setColor(input);
            });
        });
    @endif
</script>


@endsection
