<?php $__env->startSection('content'); ?>
<?php
    use App\Branches;
    use Carbon\Carbon;

    $selectedBranchId = session('selected_branch');

    $branche = Branches::where('id', $selectedBranchId)->first();

?>
    <div class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-body">
                    <div class="row">
                        <div class="col-md-6">
                            <h6 class="card-title mb-4 titlcust">Purchase Order</h6>
                        </div>
                        <div class="col-md-6">
                            <a href="<?php echo e(route('software.purchase_orders.create')); ?>">
                                <button class="btn btn-cust1 float-right" type="submit">Create Purchase Invoice</button>
                            </a>
                        </div>
                    </div>
                    <!-- <div class="col-4"> -->


                    <div class="table-responsive mb-0" data-pattern="priority-columns">
                        <table id="datatable" class="table table-bordered nowrap"
                            style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                            <thead>
                                <tr>
                                    <th>Date</th>
                                    <th>Purchase Order Number</th>
                                    <th>Action</th>
                                </tr>
                            </thead>

                            <tbody>
                                <?php $__empty_1 = true; $__currentLoopData = $purchaseOrders; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $po): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); $__empty_1 = false; ?>
                                    
                                    <tr>
                                        <td><?php echo e($po->date); ?></td>
                                        <td><?php echo e($po->invoice_no); ?></td>
                                        <td>
                                            <?php if(
                                                !empty(($branchId = session()->get('selected_branch'))) &&
                                                    Branches::hasBranchPermission($branchId, 'view-print-purchase-order')): ?>
                                                <a
                                                    href="<?php echo e(route('software.purchase_orders.show', ['purchase_order' => $po->id])); ?>">
                                                    <i class="far fa-eye cust-icon2"></i></a>
                                            <?php endif; ?>


                                            <?php if(!$po->trashed()): ?>
                                                <?php if(
                                                    !empty(($branchId = session()->get('selected_branch'))) &&
                                                        Branches::hasBranchPermission($branchId, 'edit-purchase-order')): ?>
                                                    <a
                                                        href="<?php echo e(route('software.purchase_orders.edit', ['purchase_order' => $po->id])); ?>">
                                                        <i class="far fa-edit cust-icon2"></i></a>
                                                <?php endif; ?>

                                                <?php if(
                                                    !empty(($branchId = session()->get('selected_branch'))) &&
                                                        Branches::hasBranchPermission($branchId, 'cancel-purchase-order')): ?>
                                                    <form
                                                        action="<?php echo e(route('software.purchase_orders.delete', ['purchase_order' => $po->id])); ?>"
                                                        method="POST" class="d-inline">
                                                        <?php echo csrf_field(); ?>
                                                        <?php echo method_field('DELETE'); ?>
                                                        <button onclick="return confirm('Sure want to delete?')" type="submit"
                                                            class="btn btn-link p-0 m-0 text-danger">
                                                            <i class="far fa-window-close cust-icon2"></i>
                                                        </button>
                                                    </form>
                                                <?php endif; ?>

                                                <a href="<?php echo e(route('software.purchase_invoices.create', ['po_no' => $po->invoice_no,'account_id' => $po->account_id, 'description' => $po->item_description, 'quantity' => $po->quantity,'rate_unit' => $po->rate_unit,'vat_percentage' => $po->vat_percentage,'gross_amount' => $po->gross_amount])); ?>"
                                                    class="cust-btn3">
                                                    <button type="button" class="btn btn-outline-primary">Create
                                                        Purchase Invoice</button>
                                                </a>
                                            <?php else: ?>
                                                <span class="text-danger">Deleted</span>
                                            <?php endif; ?>
                                        </td>
                                    </tr>
                                <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); if ($__empty_1): ?>
                                <?php endif; ?>
                            </tbody>
                        </table>
                    </div>


                </div>
            </div>
        </div>
    </div>
    </div>
    <!-- end row -->
<?php $__env->stopSection(); ?>

<?php echo $__env->make('layouts.crusher', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH F:\zampp 2 7.4\htdocs\acpnew-repo\resources\views/crusher/trans_purchase_order/index.blade.php ENDPATH**/ ?>