<?php $__env->startSection('content'); ?>

    <div class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-body">
                    <div class="row">
                        <div class="col-md-6">
                            <h6 class="card-title mb-4 titlcust">Stock Report
                            </h6>
                        </div>

                    </div>
                    <form action="<?php echo e(route('allStockQuery')); ?>" method="POST" class="outer-repeater" id="reportForm">
                        <?php echo csrf_field(); ?>
                        <div class="row">
                            <div class="col-md-6" id="from_date_col">
                                <div class="form-group">
                                    <label>From Date</label>
                                    <input id="from_date" name="from_date" class="form-control PeriodClosingDate" type="date" pattern="\d{4}-\d{2}-\d{2}">
                                </div>
                            </div>

                            <div class="col-md-6"  id="to_date_col">
                                <div class="form-group">
                                    <label>To Date</label>
                                    <input id="to_date" name="to_date" class="form-control PeriodClosingDate" type="date" pattern="\d{4}-\d{2}-\d{2}">
                                </div>
                            </div>

                            <div class="col-md-6">
                                <div class="form-group">
                                    <label name="ledger_account_class_name" class="control-label">Select Type of report</label>
                                    <select class="ledger_account_class form-control select2" id="query_class" name="ledger_account_class_name" required>
                                        <option value="item_query">Particulars Item Query</option>
                                        <option value="group_query">Group Stock Query</option>
                                        <option value="stock_query">Complete Stock Query</option>
                                    </select>
                                </div>
                            </div>
                            <div class="col-md-6" id="group_query">
                                <div class="form-group">
                                    <label class="control-label">Particulars</label>
                                    <select class="form-control select2" id="group_stock" name="group_stock">
                                        <option value="">Select Item Group</option>
                                        <?php $__currentLoopData = $itemGroups; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $itemGroup): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                                            <option value="<?php echo e($itemGroup->id); ?>"><?php echo e($itemGroup->name); ?></option>
                                        <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                                    </select>
                                </div>
                            </div>

                            <div class="col-md-6" id="item_query">
                                <div class="form-group">
                                    <label class="control-label">Particulars</label>
                                    <select class="form-control select2" id="item_stock" name="item_stock">
                                        <option value="">Select Item</option>
                                        <?php $__currentLoopData = $itemNames; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $item): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                                            <option value="<?php echo e($item->id); ?>"><?php echo e($item->name); ?></option>
                                        <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                                    </select>
                                </div>
                            </div>
                        </div>

                        


                        <div class="custom-control custom-switch mb-2" dir="ltr" id="showCost">
                            <input name="showCost" type="checkbox" class="custom-control-input selectallmaster" id="customSwitch75Cost" unchecked>
                            <label class="custom-control-label titlcust" for="customSwitch75Cost">
                                Show Cost
                            </label>
                        </div>

                        <div class="custom-control custom-switch mb-2" dir="ltr" id="showQty">
                            <input name="showQty" type="checkbox" class="custom-control-input selectallmaster" id="customSwitch75Qty" unchecked>
                            <label class="custom-control-label titlcust" for="customSwitch75Qty">
                                Show Cost
                            </label>
                        </div>


                        <button type="submit" class="btn btn-cust1"><i class="fas fa-check"></i>
                            Disply</button>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
<!-- end row -->

<script>
    $(document).ready(function () {
        $("#group_query ,#showQty").hide();

        $("#query_class").change(function () {
            $("#group_query, #item_query, #showCost, #showQty").hide();

            var selectedValue = $(this).val();

            if (selectedValue === "group_query") {
                $("#group_query, #showQty").show();
            } else if (selectedValue === "item_query") {
                $("#item_query, #from_date_col, #to_date_col ,#showCost").show();
            } else if (selectedValue === "stock_query") {
                $("#showQty").show();

            }
        });
    });
</script>

<?php
    use App\Branches;
    use Carbon\Carbon;

    $selectedBranchId = session('selected_branch');

    $branch = Branches::where('id', $selectedBranchId)->first();
?>

<script>
    <?php if(!empty($selectedBranchId)): ?>
        document.addEventListener("DOMContentLoaded", function() {
            var periodClosings = <?php echo json_encode($periodClosings); ?>;

            function isBeforePeriodClosing(date) {
                var selectedDate = new Date(date);
                for (var i = 0; i < periodClosings.length; i++) {
                    var closingDate = new Date(periodClosings[i]);
                    if (selectedDate < closingDate) {
                        return true;
                    }
                }
                return false;
            }

            function setColor(dateInput) {
                var selectedDate = dateInput.value;
                if (isBeforePeriodClosing(selectedDate)) {
                    dateInput.style.backgroundColor = 'lightgrey';
                } else {
                    dateInput.style.backgroundColor = '';
                }
            }

            var periodClosingDateInputs = document.querySelectorAll('.PeriodClosingDate');
            periodClosingDateInputs.forEach(function(input) {
                input.addEventListener('change', function() {
                    setColor(this);
                    if (isBeforePeriodClosing(this.value)) {
                        <?php if(!Branches::hasBranchPermission($selectedBranchId, 'View Report As Per User Credentials')): ?>
                            window.alert("You are trying to enter a closing period. Please contact admin.");
                            this.value = '';
                        <?php else: ?>
                            window.alert("You are trying to enter a closing period.");
                        <?php endif; ?>
                    }
                });
                setColor(input);
            });
        });
    <?php endif; ?>
</script>

<?php $__env->stopSection(); ?>

<?php echo $__env->make('layouts.crusher', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH F:\zampp 2 7.4\htdocs\acpnew-repo\resources\views/crusher/reports/stock_report.blade.php ENDPATH**/ ?>