<?php $__env->startSection('content'); ?>
<?php
    use App\Branches;
    use Carbon\Carbon;

    $selectedBranchId = session('selected_branch');

    $branche = Branches::where('id', $selectedBranchId)->first();

?>
    <div class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-body">
                    <div class="row">
                        <div class="col-md-6">
                            <h6 class="card-title mb-4 titlcust">Payment Voucher</h6>
                        </div>
                        <div class="col-md-6">
                            <a href="<?php echo e(route('software.payment_vouchers.create')); ?>">
                                <button class="btn btn-cust1 float-right" type="submit">Create Payment Voucher</button>
                            </a>
                        </div>
                    </div>
                    <!-- <div class="col-4"> -->


                    <div class="table-responsive mb-0" data-pattern="priority-columns">
                        <table id="datatable" class="table table-bordered nowrap"
                            style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                            <thead>
                                <tr>
                                    <th>Date</th>
                                    <th>Payment Voucher Number</th>
                                    <th>Account Name</th>
                                    <th>Amount</th>
                                    <th>Action</th>
                                </tr>
                            </thead>

                            <tbody>
                                <?php $__empty_1 = true; $__currentLoopData = $vouchers; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $voucher): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); $__empty_1 = false; ?>
                                    
                                    <tr>
                                        <td><?php echo e($voucher->date); ?></td>
                                        <td><?php echo e($voucher->invoice_no); ?></td>
                                        <td>
                                            <?php if(!empty($voucher->expense[0]->account)): ?>
                                                <?php echo e($voucher->expense[0]->account->name_of_organisation ?? ($voucher->expense[0]->account->account_name ?? $voucher->expense[0]->account->first_name . ' ' . $voucher->expense[0]->account->last_name)); ?>

                                            <?php endif; ?>
                                        </td>
                                        
                                        <?php if(!$voucher->trashed()): ?>
                                        <td><?php echo e(number_format($voucher->expense->sum('amount') + $voucher->expense->sum('expense_amount'), session('branch')->currency_decimal)); ?></td>
                                        <?php else: ?>
                                            <td>-</td>
                                        <?php endif; ?>
                                        <td>
                                            <?php if(
                                                !empty(($branchId = session()->get('selected_branch'))) &&
                                                    Branches::hasBranchPermission($branchId, 'view-print-payment-voucher')): ?>
                                                <a
                                                    href="<?php echo e(route('software.payment_vouchers.show', ['payment_voucher' => $voucher->id])); ?>">
                                                    <i class="far fa-eye cust-icon2"></i></a>
                                            <?php endif; ?>


                                            <?php if(!$voucher->trashed()): ?>
                                                <?php if(
                                                    !empty(($branchId = session()->get('selected_branch'))) &&
                                                        Branches::hasBranchPermission($branchId, 'edit-payment-voucher')): ?>
                                                    <a
                                                        href="<?php echo e(route('software.payment_vouchers.edit', ['payment_voucher' => $voucher->id])); ?>">
                                                        <i class="far fa-edit cust-icon2"></i></a>
                                                <?php endif; ?>

                                                <?php if(
                                                    !empty(($branchId = session()->get('selected_branch'))) &&
                                                            Branches::hasBranchPermission($branchId, 'cancel-payment-voucher')): ?>
                                                    <form
                                                        action="<?php echo e(route('software.payment_vouchers.delete', ['payment_voucher' => $voucher->id])); ?>"
                                                        method="POST" class="d-inline">
                                                        <?php echo csrf_field(); ?>
                                                        <?php echo method_field('DELETE'); ?>
                                                        <input type="hidden" name="invoice_no"
                                                            value="<?php echo e($voucher->invoice_no); ?>">
                                                        <button onclick="return confirm('Sure want to delete?')" type="submit"
                                                            class="btn btn-link p-0 m-0 text-danger">
                                                            <i class="far fa-window-close cust-icon2"></i>
                                                        </button>
                                                    </form>
                                                <?php endif; ?>

                                            <?php else: ?>
                                                <span class="text-danger">Deleted</span>
                                            <?php endif; ?>
                                        </td>
                                    </tr>
                                <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); if ($__empty_1): ?>
                                <?php endif; ?>
                            </tbody>
                        </table>
                    </div>


                </div>
            </div>
        </div>
    </div>
    </div>
    <!-- end row -->
<?php $__env->stopSection(); ?>

<?php echo $__env->make('layouts.crusher', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH F:\zampp 2 7.4\htdocs\acpnew-repo\resources\views/crusher/trans_payment_voucher/index.blade.php ENDPATH**/ ?>