<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\AccountMaster;
use App\AccountMastersAccountsDetail;
use App\ClassOfAccount;
use App\Currency;
use App\Http\Controllers\Controller;
use App\PurchaseInvoice;
use App\PurchaseReturnVoucher;
use App\SaleInvoice;
use App\SalesReturnVoucher;
use App\Services\Utils;
use Carbon\Carbon;
use PDF;
use Auth;
use App\Customer;
use App\Expense;
use App\Supplier;
use App\StaffAndSalesman;
use App\AdminOtherAccount;
use App\AdminSalesInvoice;
use App\AdminJournalVoucher;
use App\AdminReceiptVoucher;
use App\ReceiptVoucherExpense;
use App\PaymentVoucherExpense ;
use App\Company;
use App\DeliveryNote;
use App\CreditNote;
use App\DebitNote;
use App\OpeningBalance;
use App\PurchaseOrder;
use App\Quotation;
use App\WarehouseTransfer;
use App\AdminPurchaesInvoice;
use App\AdminPaymentVoucher;
use App\AdminTermsAndCondition;
use Illuminate\Support\Facades\DB;

class VatReportController extends Controller
{
    public function display()
    {

        return view('crusher.reports.vat_ledger_report_display');
    }
    public function vatLedgerReport(Request $request)
    {
        $lastFromDate = date("2003-01-01");
        $from_date = $request->from_date;
        $to_date = $request->to_date;
        $lastDay = Carbon::parse($to_date)->subDay()->format('Y-m-d');

        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

        $customer = Customer::where('branch_id', session()->get('selected_branch'))->get()->toArray();
        $staffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))->get()->toArray();
        $supplier = Supplier::where('branch_id', session()->get('selected_branch'))->get()->toArray();
        $expense = Expense::where('branch_id', session()->get('selected_branch'))->get()->toArray();
        $adminOtherAccount = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))->get()->toArray();

        $allAccounts = array_merge($customer, $staffAndSalesman, $supplier, $expense, $adminOtherAccount);

        // $PurchaesInvoice = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
        //     ->where('date', '>=', $from_date . ' 00:00:00')
        //     ->where('date', '<=', $to_date . ' 23:59:59')
        //     ->groupBy('invoice_no')
        //     ->orderBy('invoice_no', 'asc')
        //     ->get()
        //     ->toArray();

        $ncustomer = Customer::where('branch_id', session()->get('selected_branch'))->pluck('id')->toArray();
        $nstaffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))->pluck('id')->toArray();
        $nsupplier = Supplier::where('branch_id', session()->get('selected_branch'))->pluck('id')->toArray();
        $nexpense = Expense::where('branch_id', session()->get('selected_branch'))->pluck('id')->toArray();
        $nadminOtherAccount = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))->pluck('id')->toArray();

        $allAccountIds = array_merge($ncustomer, $nstaffAndSalesman, $nsupplier, $nexpense, $nadminOtherAccount);

        $PurchaesInvoice = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
            ->whereIn('account_id', $allAccountIds)
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->groupBy('invoice_no')
            ->orderBy('invoice_no', 'asc')
            ->get();

        $SaleInvoice = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
            ->whereIn('account_id', $allAccountIds)
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->groupBy('invoice_no')
            ->orderBy('date', 'asc')
            ->get();

        $CreditNote = CreditNote::with('expense')->where('branch_id', session()->get('selected_branch'))
        ->whereIn('account_id', $allAccountIds)
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->groupBy('invoice_no')
            ->get();
        $DebitNote = DebitNote::with('expense')->where('branch_id', session()->get('selected_branch'))
        ->whereIn('account_id', $allAccountIds)
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->groupBy('invoice_no')
            ->get();

        $allData = $PurchaesInvoice ->concat($SaleInvoice)->concat($CreditNote)->concat($DebitNote);

        // dd($allData);

        $ObPurchaesInvoice = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->groupBy('invoice_no')
            ->get()
            ->toArray();

        $ObSaleInvoice = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->groupBy('invoice_no')
            ->get()
            ->toArray();

        $ObCreditNote = CreditNote::with('expense')->where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->groupBy('invoice_no')
            ->get()
            ->toArray();
        $ObDebitNote = DebitNote::with('expense')->where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->get()
            ->toArray();
        $ObPurchaseOrder = PurchaseOrder::with('expense')->where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->groupBy('invoice_no')
            ->get()
            ->toArray();
        $ObQuotation = Quotation::with('expense')->where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->groupBy('quotation_no')
            ->get()
            ->toArray();


        $purchaesInvoiceData = [];
        $saleInvoiceData = [];
        $CreditNoteData = [];
        $DebitNoteData = [];
        $PurchaseOrderData = [];
        $QuotationData = [];

        $ObpurchaesInvoiceData = [];
        $ObsaleInvoiceData = [];
        $ObCreditNoteData = [];
        $ObDebitNoteData = [];
        $ObPurchaseOrderData = [];
        $ObQuotationData = [];

        // foreach ($allAccounts as $account) {
        //     $accountId = $account['id'];

        //     $purchaseInvoiceMatch = array_filter($PurchaesInvoice, function ($invoice) use ($accountId) {
        //         return $invoice['account_id'] == $accountId;
        //     });

        //     $saleInvoiceMatch = array_filter($SaleInvoice, function ($invoice) use ($accountId) {
        //         return $invoice['account_id'] == $accountId;
        //     });

        //     $CreditNoteMatch = array_filter($CreditNote, function ($invoice) use ($accountId) {
        //         return $invoice['account_id'] == $accountId;
        //     });
        //     $DebitNoteMatch = array_filter($DebitNote, function ($invoice) use ($accountId) {
        //         return $invoice['account_id'] == $accountId;
        //     });
        //     $PurchaseOrderMatch = array_filter($PurchaseOrder, function ($invoice) use ($accountId) {
        //         return $invoice['account_id'] == $accountId;
        //     });
        //     $QuotationMatch = array_filter($Quotation, function ($invoice) use ($accountId) {
        //         return $invoice['account_id'] == $accountId;
        //     });

        //     if (!empty($purchaseInvoiceMatch)) {
        //         $purchaesInvoiceData[$accountId] = $purchaseInvoiceMatch;
        //     }

        //     if (!empty($saleInvoiceMatch)) {
        //         $saleInvoiceData[$accountId] = $saleInvoiceMatch;
        //     }

        //     if (!empty($CreditNoteMatch)) {
        //         $CreditNoteData[$accountId] = $CreditNoteMatch;
        //     }
        //     if (!empty($DebitNoteMatch)) {
        //         $DebitNoteData[$accountId] = $DebitNoteMatch;
        //     }
        //     if (!empty($PurchaseOrderMatch)) {
        //         $PurchaseOrderData[$accountId] = $PurchaseOrderMatch;
        //     }
        //     if (!empty($QuotationMatch)) {
        //         $QuotationData[$accountId] = $QuotationMatch;
        //     }
        // }
        foreach ($allAccounts as $account) {
            $accountId = $account['id'];

            $ObpurchaseInvoiceMatch = array_filter($ObPurchaesInvoice, function ($invoice) use ($accountId) {
                return $invoice['account_id'] == $accountId;
            });

            $ObsaleInvoiceMatch = array_filter($ObSaleInvoice, function ($invoice) use ($accountId) {
                return $invoice['account_id'] == $accountId;
            });

            $ObCreditNoteMatch = array_filter($ObCreditNote, function ($invoice) use ($accountId) {
                return $invoice['account_id'] == $accountId;
            });
            $ObDebitNoteMatch = array_filter($ObDebitNote, function ($invoice) use ($accountId) {
                return $invoice['account_id'] == $accountId;
            });
            $ObPurchaseOrderMatch = array_filter($ObPurchaseOrder, function ($invoice) use ($accountId) {
                return $invoice['account_id'] == $accountId;
            });
            $ObQuotationMatch = array_filter($ObQuotation, function ($invoice) use ($accountId) {
                return $invoice['account_id'] == $accountId;
            });

            if (!empty($ObpurchaseInvoiceMatch)) {
                $ObpurchaesInvoiceData[$accountId] = $ObpurchaseInvoiceMatch;
            }

            if (!empty($ObsaleInvoiceMatch)) {
                $ObsaleInvoiceData[$accountId] = $ObsaleInvoiceMatch;
            }

            if (!empty($ObCreditNoteMatch)) {
                $ObCreditNoteData[$accountId] = $ObCreditNoteMatch;
            }
            if (!empty($ObDebitNoteMatch)) {
                $ObDebitNoteData[$accountId] = $ObDebitNoteMatch;
            }
            if (!empty($ObPurchaseOrderMatch)) {
                $ObPurchaseOrderData[$accountId] = $ObPurchaseOrderMatch;
            }
            if (!empty($ObQuotationMatch)) {
                $ObQuotationData[$accountId] = $ObQuotationMatch;
            }
        }

        $saleInvoiceData = collect($saleInvoiceData);
        $purchaesInvoiceData = collect($purchaesInvoiceData);
        $CreditNoteData = collect($CreditNoteData);
        $DebitNoteData = collect($DebitNoteData);
        $PurchaseOrderData = collect($PurchaseOrderData);
        $QuotationData = collect($QuotationData);


        // $allData = $saleInvoiceData ->concat($purchaesInvoiceData)->concat($CreditNoteData)->concat($DebitNoteData)->concat($PurchaseOrderData)->concat($QuotationData);

        // dd($allData);


        // dd('Purchaes Invoice Data:', $purchaesInvoiceData, 'Sale Invoice Data:', $saleInvoiceData, 'Journal Voucher Match', $JournalVoucherMatch , 'Receipt Voucher Data', $ReceiptVoucherData);

        // dd($ObsaleInvoiceData,$ObpurchaesInvoiceData);

        return view('crusher.reports.vvat-ledger-report', compact('from_date', 'to_date','allAccounts', 'saleInvoiceData','purchaesInvoiceData','CreditNoteData','DebitNoteData','PurchaseOrderData','QuotationData','ObsaleInvoiceData','ObpurchaesInvoiceData','ObCreditNoteData','ObDebitNoteData','ObPurchaseOrderData','ObQuotationData','allData'));
    }
}


