<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class PurchaseReturnVoucherItem extends Model
{
    use SoftDeletes;
    /**
     * The table associated with the model.
     *
     * @var string
     */
    protected $table = 'purchase_return_voucher_items';

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'purchase_return_voucher_id',
        'imei_serial_no',
        'quantity',
        'rate_per_quantity',
        'amount',
        'remarks',
    ];


    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
    ];

    //'foreign_key', 'local_key'
    public function name()
    {
        return $this->belongsTo('App\ItemName', 'item_name_id', 'id');
    }

    public function unit()
    {
        return $this->belongsTo('App\ItemUnit', 'item_unit_id', 'id');
    }

    public function invoice()
    {
        return $this->belongsTo('App\PurchaseReturnVoucher', 'purchase_return_voucher_id', 'id');
    }

    public function purchase_items()
    {
        return $this->belongsTo('App\PurchaseInvoiceItem', 'imei_serial_no', 'imei_serial_no');
    }
}
