@extends('layouts.crusher')
@section('content')
    <div class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-body">
                    <div class="row">
                        <div class="col-md-6">
                            <h6 class="card-title mb-4 titlcust">Sale Report
                            </h6>
                        </div>

                    </div>
                    <div class="row">
                        <div class="col-md-6">
                        </div>
                        <div class="col-md-6">
                            <div class="btn-group float-right" role="group" aria-label="Basic example">
                                <a href="" type="button" class="btn btn-outline-primary"><i
                                        class="fas fa-mail-bulk"></i> Email (PDF Formate)</a>
                                <a class="btn btn-outline-primary"
                                    onclick="printPageArea('printableArea')"> Print & PDF
                                    Formate</a>

                            </div>
                        </div>
                    </div>
                    <br>

                    <div class="table-responsive mb-0" data-pattern="priority-columns">
                        <table id="printableArea" id="" class="table table-bordered dt-responsive nowrap"
                            style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                            <thead>
                                <tr>
                                    <th>Date</th>
                                    <th>Particulars</th>
                                    <th>Voucher Description</th>
                                    <th>Debit</th>
                                    <th>Credit</th>
                                </tr>
                            </thead>

                            <tbody id="dataBody" style="display: none;">
                                @php
                                    $totalDebits = 0;
                                    $totalCredits = 0;
                                @endphp

                                @foreach ($mergedData as $data)
                                {{-- @dd($data) --}}
                                <tr data-date="{{ \Carbon\Carbon::parse($data->date)->format('Y-m-d') }}">
                                    <td>{{ \Carbon\Carbon::parse($data->date)->format('d/m/Y') }}</td>
                                    <td>
                                        <span>{{ $data->account->name_of_organisation ?? ($data->account->account_name ?? $data->account->first_name . ' ' . $data->account->last_name) }}</span>
                                    </td>
                                    <td>
                                        @if ($data instanceof \App\AdminSalesInvoice)
                                            <td>Sales# {{ $data->invoice_no }}</td>
                                        @elseif ($data instanceof \App\DebitNote)
                                            <td>DebitNote# {{ $data->invoice_no }}</td>
                                        @else
                                            <td>-</td>
                                        @endif
                                    </td>
                                    <td>
                                        @if ($data instanceof \App\AdminSalesInvoice)
                                            {{ $data->total_net_amount }}
                                            @php
                                                $totalDebits += $data->total_net_amount;
                                            @endphp
                                        @elseif ($data instanceof \App\DebitNote)
                                            {{ $data->total_net_amount }}
                                            @php
                                                $totalCredits += $data->total_net_amount;
                                            @endphp
                                        @else
                                            -
                                        @endif
                                    </td>
                                </tr>
                                @endforeach

                                {{-- <tr>
                                    <td colspan="3">Total Credit</td>
                                    <td></td>
                                    <td>{{ $totalCredits }}</td>
                                </tr>
                                <tr>
                                    <td colspan="3">Total Debit</td>
                                    <td>{{ $totalDebits }}</td>
                                    <td></td>
                                </tr>
                                <tr>
                                    <td colspan="4">Total</td>
                                    <td>{{ $totalDebits * $totalCredits }}</td>
                                </tr> --}}
                                <tr id="totalsRow">
                                    <td colspan="3">Total</td>
                                    <td id="totalDebit"></td>
                                    <td id="totalCredit"></td>
                                    <td id="grandTotal"></td>
                                </tr>

                            </tbody>
                        </table>


                    </div>
                </div>
            </div>
        </div>
    </div>
    </div>
    <!-- end row -->
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
    <script>
        function printPageArea(areaID) {
            var printContent = document.getElementById(areaID).innerHTML;
            var originalContent = document.body.innerHTML;
            document.body.innerHTML = printContent;
            window.print();
            document.body.innerHTML = originalContent;
        }
    </script>
@endsection
