@extends('layouts.master_user_without_nav')
@section('css')
<style>
    .top {
        margin-top: 50px;
    }

    h2 {
        text-align: center;
        margin-bottom: 20px;
    }

</style>
@endsection
@section('content')
<div class=" container wrapper wrapper-content animated fadeInRight">
    <div class="row" style="margin-bottom: 20px;">
        <a href="/" class="btn btn-primary">Go Back</a>
    </div>
    <div class="row gray-bg">
        <h2><strong>Add Country & Location</strong></h2>
    </div>
    <div class="row top">
        <div class="col-md-12">
            @include('errors.list')
        </div>
    </div>
    <div class="row top">
        <div class="col-lg-6">
            <h3><strong>Add Particular Country</strong></h3>
            <div class="ibox-content">
                <form class="form-horizontal" method="POST" action="/main-menu/countries-and-locations/create-country">
                    @csrf
                    <div class="form-group">
                        <label for="name" class="pull-left">Country</label>
                        <input type="text" class="form-control" name="name" id="name"
                            placeholder="Country" required>
                    </div>
                    <div class="form-group">
                        <input type="submit" value="Add Country" class="btn btn-primary block full-width">
                    </div>

                </form>

            </div>

            <div class="table-responsive">
                <table class="table table-striped table-bordered table-hover dt-responsive" >
                <thead>
                <tr>
                    <th>Country Name</th>
                    <th>Action</th>
                </tr>
                </thead>
                <tbody>
                    @foreach($countries as $country)
                    <tr>
                        <td>{{ $country->name }}</td>
                        <td>
                            <div class="btn-group">
                                <div class="pull-left" style="margin-right: 10px;">
                                    <a href="/main-menu/countries-and-locations/country/{{ $country->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                                </div>
                                <div class="pull-right">
                                    <form  method="post" action="/main-menu/countries-and-locations/country/{{ $country->id }}">
                                        {{ csrf_field() }}
                                        {{ method_field('DELETE') }}
                                        <button type="submit" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Delete</button>
                                    </form>
                                </div>
                            </div>
                        </td>
                    </tr>
                    @endforeach
                </tbody>
                </table>
            </div>

        </div>
        <div class="col-lg-6 ">
            <h3><strong>Add Location in Particular Country</strong></h3>
            <div class="ibox-content">

                <form class="form-horizontal" method="POST" action="/main-menu/countries-and-locations/create-location">
                    @csrf
                    <div class="form-group">
                        <label for="country" class="pull-left"> Select Country</label>
                        <select class="form-control" name="country">
                            @foreach ($countries as $country)
                                <option value="{{$country-> id}}">{{$country-> name}}</option>
                            @endforeach
                        </select>

                    </div>
                    <div class="form-group">
                        <label for="name" class="pull-left">Location</label>
                        <input type="text" class="form-control" name="name" id="name"
                            placeholder="Location">
                    </div>
                    <div class="form-group">
                        <input type="submit" value="Add Location" class="btn btn-primary block full-width m-b">
                    </div>
                </form>
            </div>

            <div class="table-responsive">
                <table class="table table-striped table-bordered table-hover dt-responsive" >
                <thead>
                <tr>
                    <th>Country Name</th>
                    <th>Location Name</th>
                    <th>Action</th>
                </tr>
                </thead>
                <tbody>
                    @foreach($locations as $location)
                    <tr>
                        <td>{{ $location->country['name'] }}</td>
                        <td>{{ $location->name }}</td>
                        <td>
                            <div class="btn-group">
                                <div class="pull-left" style="margin-right: 10px;">
                                    <a href="/main-menu/countries-and-locations/location/{{ $location->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                                </div>
                                <div class="pull-right">
                                    <form  method="post" action="/main-menu/countries-and-locations/location/{{ $location->id }}">
                                        {{ csrf_field() }}
                                        {{ method_field('DELETE') }}
                                        <button type="submit" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Delete</button>
                                    </form>
                                </div>
                            </div>
                        </td>
                    </tr>
                    @endforeach
                </tbody>
                </table>
            </div>

        </div>
    </div>
</div>




@endsection

@section('js')
<script>
</script>
@endsection
