@extends('layouts.master_user_without_nav')
@section('css')
<style>
    .margin_top{
        margin-top: 50px;
    }
    h2{
        margin-bottom: 20px;
    }
    #custom-search-input {
        padding: 3px;
        border: solid 1px #E4E4E4;
        border-radius: 6px;
        background-color: #fff;
    }

    #custom-search-input input {
        border: 0;
        box-shadow: none;
    }

    #custom-search-input button {
        margin: 2px 0 0 0;
        background: none;
        box-shadow: none;
        border: 0;
        color: #666666;
        padding: 0 8px 0 10px;
        border-left: solid 1px #ccc;
    }

    #custom-search-input button:hover {
        border: 0;
        box-shadow: none;
        border-left: solid 1px #ccc;
    }

    #custom-search-input .glyphicon-search {
        font-size: 23px;
    }


</style>
@endsection
@section('content')
<div class="container wrapper wrapper-content animated fadeInRight">
    <div class="row gray-bg margin_top" style="margin-bottom: 50px;">
        <h2 class="text-center"><strong>Search Result For {{$search}}</strong></h2>
    </div>

    <div class="table-responsive">

        {{-- ApprovalVoucherResult --}}
        <table class="table table-striped table-bordered table-hover dt-responsive" style="margin-bottom: 50px;">
            <thead>
                <tr>
                    <th colspan="4" style="text-align: center">Results In Approval Vouchers</th>
                </tr>
                <tr>
                    <th>Invoice Number</th>
                    <th>Invoice Type</th>
                    <th>Account</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>
                @if (count($approval_voucher_result) > 0)
                    @foreach($approval_voucher_result as $approval)
                        <tr>
                            <td>{{$approval->invoice_no}}</td>
                            <td>Approval Voucher</td>
                            <td>{{$approval->account->name_of_organisation}}</td>
                            <td>
                                {{-- <div class="btn-group">
                                    <div class="pull-left" style="margin-right: 10px;">
                                        <a href="/transactions/approval-vouchers/{{ $approval->id }}/view" class="btn btn-primary">
                                            <i class="fa fa-eye" aria-hidden="true"></i>
                                            View
                                        </a>
                                    </div>
                                    <div class="pull-left" style="margin-right: 10px;">
                                        <a href="/transactions/approval-vouchers/{{ $approval->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                                    </div>
                                    <div class="pull-right">
                                        <form  method="post" action="/transactions/approval-vouchers/{{ $approval->id }}/softdelete">
                                            {{ csrf_field() }}
                                            {{ method_field('DELETE') }}
                                            <button type="submit" class="btn btn-primary">
                                                <i class="fa fa-trash" aria-hidden="true"></i>
                                                Cancel</button>
                                        </form>
                                    </div>
                                </div> --}}
                                @if ($approval->deleted_at != "")
                                        <button type="button" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancelled</button>
                                @else
                                    <div class="btn-group">
                                        @can('view-print-approval-voucher')
                                        <div class="pull-left" style="margin-right: 10px;">
                                            <a href="/transactions/approval-vouchers/{{ $approval->id }}/view" class="btn btn-primary"><i class="fa fa-eye" aria-hidden="true"></i> View</a>
                                        </div>
                                        @endcan

                                        @can('edit-approval-voucher-delivery-notes')
                                        <div class="pull-left" style="margin-right: 10px;">
                                            <a href="/transactions/approval-vouchers/{{ $approval->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                                        </div>
                                        @endcan

                                        @can('cancel-approval-voucher-delivery-notes')
                                        <div class="pull-left" style="margin-right: 10px;">
                                            <form  method="post" action="/transactions/approval-vouchers/{{ $approval->id }}/softdelete">
                                                {{ csrf_field() }}
                                                {{ method_field('DELETE') }}
                                                <button type="submit" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancel</button>
                                            </form>
                                        </div>
                                        @endcan
                                        @if ($approval->is_signed == 1)
                                            <div class="pull-right" style="margin-right: 10px;">
                                                <a href="/public/user_files/img/client_signs/{{$approval->signature_path}}" target="blank" type="button" class="btn btn-primary"><i class="fa fa-check"></i> Signed</a>
                                            </div>
                                        @else
                                            <div class="pull-right" style="margin-right: 10px;">
                                                <a href="/transactions/approval-vouchers/signature/{{ $approval->id }}/create" type="button" class="btn btn-primary"><i class="fa fa-file-text"></i> Signature</a>
                                            </div>
                                        @endif
                                    </div>
                                @endif
                            </td>
                        </tr>
                    @endforeach
                @else
                    <td colspan="4">No Results Found</td>
                @endif
            </tbody>
        </table>

        {{-- SalesInvoiceResult --}}
        <table class="table table-striped table-bordered table-hover dt-responsive" style="margin-bottom: 50px;">
            <thead>
                <tr>
                    <th colspan="4" style="text-align: center">Results In Sales Invoices</th>
                </tr>
                <tr>
                    <th>Invoice Number</th>
                    <th>Invoice Type</th>
                    <th>Account</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>
                @if (count($sales_invoice_result) > 0)
                    @foreach($sales_invoice_result as $sales)
                        <tr>
                            <td>{{$sales->invoice_no}}</td>
                            <td>Sales Invoice</td>
                            <td>{{$sales->account->name_of_organisation}}</td>
                            <td>
                                {{-- <div class="btn-group">
                                    <div class="pull-left" style="margin-right: 10px;">
                                        <a href="/transactions/sales-invoices/{{ $sales->id }}/view" class="btn btn-primary">
                                            <i class="fa fa-eye" aria-hidden="true"></i>
                                            View
                                        </a>
                                    </div>
                                    <div class="pull-left" style="margin-right: 10px;">
                                        <a href="/transactions/sales-invoices/{{ $sales->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                                    </div>
                                    <div class="pull-right">
                                        <form  method="post" action="/transactions/sales-invoices/{{ $sales->id }}/softdelete">
                                            {{ csrf_field() }}
                                            {{ method_field('DELETE') }}
                                            <button type="submit" class="btn btn-primary">
                                                <i class="fa fa-trash" aria-hidden="true"></i>
                                                Cancel</button>
                                        </form>
                                    </div>
                                </div> --}}
                                @if ($sales->deleted_at != "")
                                    <button type="button" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancelled</button>
                                @else
                                    <div class="btn-group">
                                        @can('view-print-sales-voucher')
                                        <div class="pull-left" style="margin-right: 10px;">
                                            <a href="/transactions/sales-invoices/{{ $sales->id }}/view" class="btn btn-primary"><i class="fa fa-eye" aria-hidden="true"></i> View</a>
                                        </div>
                                        @endcan
                                        @if ($sales->paid_amount == 0)
                                            @can('edit-sales-voucher')
                                            <div class="pull-left" style="margin-right: 10px;">
                                                <a href="/transactions/sales-invoices/{{ $sales->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                                            </div>
                                            @endcan
                                            @can('cancel-sales-voucher')
                                            <div class="pull-left" style="margin-right: 10px;">
                                                <form  method="post" action="/transactions/sales-invoices/{{ $sales->id }}/softdelete">
                                                    {{ csrf_field() }}
                                                    {{ method_field('DELETE') }}
                                                    <button type="submit" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancel</button>
                                                </form>
                                            </div>
                                            @endcan
                                        @else
                                            <div class="pull-left" style="margin-right: 10px;">
                                                <button type="button" disabled class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</button>
                                            </div>
                                            <div class="pull-left" style="margin-right: 10px;">
                                                <button type="button" disabled class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancel</button>
                                            </div>
                                        @endif
                                        @if ($sales->is_signed == 1)
                                            <div class="pull-right" style="margin-right: 10px;">
                                                <a href="/public/user_files/img/client_signs/{{$sales->signature_path}}" target="blank" type="button" class="btn btn-primary"><i class="fa fa-check"></i> Signed</a>
                                            </div>
                                        @else
                                            <div class="pull-right" style="margin-right: 10px;">
                                                <a href="/transactions/sales-invoices/signature/{{ $sales->id }}/create" type="button" class="btn btn-primary"><i class="fa fa-file-text"></i> Signature</a>
                                            </div>
                                        @endif
                                    </div>
                                @endif
                            </td>
                        </tr>
                    @endforeach
                @else
                    <td colspan="4">No Results Found</td>
                @endif
            </tbody>
        </table>

        {{-- PurchaseInvoiceResult --}}
        <table class="table table-striped table-bordered table-hover dt-responsive" style="margin-bottom: 50px;">
            <thead>
                <tr>
                    <th colspan="4" style="text-align: center">Results In Purchase Invoices</th>
                </tr>
                <tr>
                    <th>Invoice Number</th>
                    <th>Invoice Type</th>
                    <th>Account</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>
                @if (count($purchase_invoice_result) > 0)
                    {{-- @foreach($purchase_invoice_result as $purchase)
                        <tr>
                            <td>{{$purchase->invoice_no}}</td>
                            <td>Purchase Invoice</td>
                            <td>{{$purchase->account->name_of_organisation}}</td>
                            <td>
                                <div class="btn-group">
                                    <div class="pull-left" style="margin-right: 10px;">
                                        <a href="/transactions/purchase-invoices/{{ $purchase->id }}/view" class="btn btn-primary">
                                            <i class="fa fa-eye" aria-hidden="true"></i>
                                            View
                                        </a>
                                    </div>
                                    <div class="pull-left" style="margin-right: 10px;">
                                        <a href="/transactions/purchase-invoices/{{ $purchase->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                                    </div>
                                    <div class="pull-right">
                                        <form  method="post" action="/transactions/purchase-invoices/{{ $purchase->id }}/softdelete">
                                            {{ csrf_field() }}
                                            {{ method_field('DELETE') }}
                                            <button type="submit" class="btn btn-primary">
                                                <i class="fa fa-trash" aria-hidden="true"></i>
                                                Cancel</button>
                                        </form>
                                    </div>
                                </div>
                            </td>
                        </tr>
                    @endforeach --}}
                    @foreach($purchase_invoice_result as $key => $purchase_invoice)
                        <tr>
                            <td>{{ $purchase_invoice_result[$key]->invoice_no }}</td>
                            <td>Purchase Invoice</td>
                            @if ($purchase_invoice_result[$key]->invoice_no > 0 && $purchase_invoice_result[$key]->account != '')
                                <td>{{ $purchase_invoice_result[$key]->account->name_of_organisation }}</td>
                            @else
                                <td>opening balance for inventory</td>
                            @endif
                            <td>
                                @if ($purchase_invoice_result[$key]->deleted_at != "")
                                    <button type="button" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancelled</button>
                                @else
                                    <div class="btn-group">
                                        @can('view-Print-purchase-voucher')
                                        <div class="pull-left" style="margin-right: 10px;">
                                            <a href="/transactions/purchase-invoices/{{ $purchase_invoice_result[$key]->id }}/view" class="btn btn-primary"><i class="fa fa-eye" aria-hidden="true"></i> View</a>
                                        </div>
                                        @endcan
                                        @if ($purchase_invoice_result[$key]->paid_amount == 0 && $sales_items[$key] == "")
                                            @can('edit-purchase-voucher')
                                            <div class="pull-left" style="margin-right: 10px;">
                                                <a href="/transactions/purchase-invoices/{{ $purchase_invoice_result[$key]->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                                            </div>
                                            @endcan

                                            @can('cancel-purchase-voucher')
                                            <div class="pull-left" style="margin-right: 10px;">
                                                <form  method="post" action="/transactions/purchase-invoices/{{ $purchase_invoice_result[$key]->id }}/softdelete">
                                                    {{ csrf_field() }}
                                                    {{ method_field('DELETE') }}
                                                    <button type="submit" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancel</button>
                                                </form>
                                            </div>
                                            @endcan
                                        @else
                                            <div class="pull-left" style="margin-right: 10px;">
                                                <button type="button" disabled class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</button>
                                            </div>
                                            <div class="pull-left" style="margin-right: 10px;">
                                                <button type="button" disabled class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancel</button>
                                            </div>
                                        @endif
                                        @if ($purchase_invoice->is_signed == 1)
                                            <div class="pull-right" style="margin-right: 10px;">
                                                <a href="/public/user_files/img/client_signs/{{$purchase_invoice->signature_path}}" target="blank" type="button" class="btn btn-primary"><i class="fa fa-check"></i> Signed</a>
                                            </div>
                                        @else
                                            <div class="pull-right" style="margin-right: 10px;">
                                                <a href="/transactions/purchase-invoices/signature/{{ $purchase_invoice->id }}/create" type="button" class="btn btn-primary"><i class="fa fa-file-text"></i> Signature</a>
                                            </div>
                                        @endif
                                    </div>
                                @endif
                            </td>
                        </tr>
                    @endforeach
                @else
                    <td colspan="4">No Results Found</td>
                @endif
            </tbody>
        </table>

        {{-- SalesReturnInvoiceResult --}}
        <table class="table table-striped table-bordered table-hover dt-responsive" style="margin-bottom: 50px;">
            <thead>
                <tr>
                    <th colspan="4" style="text-align: center">Results In Sales Return Vouchers</th>
                </tr>
                <tr>
                    <th>Invoice Number</th>
                    <th>Invoice Type</th>
                    <th>Account</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>
                @if (count($sales_return_invoice_result) > 0)
                    @foreach($sales_return_invoice_result as $sales_return)
                        <tr>
                            <td>{{$sales_return->invoice_no}}</td>
                            <td>Sales Return Invoice</td>
                            <td>{{$sales_return->account->name_of_organisation}}</td>
                            <td>
                                {{-- <div class="btn-group">
                                    <div class="pull-left" style="margin-right: 10px;">
                                        <a href="/transactions/sales-return-vouchers/{{ $sales_return->id }}/view" class="btn btn-primary">
                                            <i class="fa fa-eye" aria-hidden="true"></i>
                                            View
                                        </a>
                                    </div>
                                    <div class="pull-left" style="margin-right: 10px;">
                                        <a href="/transactions/sales-return-vouchers/{{ $sales_return->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                                    </div>
                                    <div class="pull-right">
                                        <form  method="post" action="/transactions/sales-return-vouchers/{{ $sales_return->id }}/softdelete">
                                            {{ csrf_field() }}
                                            {{ method_field('DELETE') }}
                                            <button type="submit" class="btn btn-primary">
                                                <i class="fa fa-trash" aria-hidden="true"></i>
                                                Cancel</button>
                                        </form>
                                    </div>
                                </div> --}}
                                @if ($sales_return->deleted_at != "")
                                    <button type="button" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancelled</button>
                                @else
                                    <div class="btn-group">
                                        @can('view-print-credit-note-sales-return-voucher')
                                        <div class="pull-left" style="margin-right: 10px;">
                                            <a href="/transactions/sales-return-vouchers/{{ $sales_return->id }}/view" class="btn btn-primary"><i class="fa fa-eye" aria-hidden="true"></i> View</a>
                                        </div>
                                        @endcan
                                        @can('edit-credit-note-sales-return-voucher')
                                        <div class="pull-left" style="margin-right: 10px;">
                                            <a href="/transactions/sales-return-vouchers/{{ $sales_return->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                                        </div>
                                        @endcan

                                        @can('cancel-credit-note-sales-return-voucher')
                                        <div class="pull-left" style="margin-right: 10px;">
                                            <form  method="post" action="/transactions/sales-return-vouchers/{{ $sales_return->id }}/softdelete">
                                                {{ csrf_field() }}
                                                {{ method_field('DELETE') }}
                                                <button type="submit" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancel</button>
                                            </form>
                                        </div>
                                        @endcan
                                        @if ($sales_return->is_signed == 1)
                                            <div class="pull-right" style="margin-right: 10px;">
                                                <a href="/public/user_files/img/client_signs/{{$sales_return->signature_path}}" target="blank" type="button" class="btn btn-primary"><i class="fa fa-check"></i> Signed</a>
                                            </div>
                                        @else
                                            <div class="pull-right" style="margin-right: 10px;">
                                                <a href="/transactions/sales-return-vouchers/signature/{{ $sales_return->id }}/create" type="button" class="btn btn-primary"><i class="fa fa-file-text"></i> Signature</a>
                                            </div>
                                        @endif
                                    </div>
                                @endif
                            </td>
                        </tr>
                    @endforeach
                @else
                    <td colspan="4">No Results Found</td>
                @endif
            </tbody>
        </table>

        {{-- PurchaseReturnInvoiceResult --}}
        <table class="table table-striped table-bordered table-hover dt-responsive" style="margin-bottom: 50px;">
            <thead>
                <tr>
                    <th colspan="4" style="text-align: center">Results In Purchase Return Vouchers</th>
                </tr>
                <tr>
                    <th>Invoice Number</th>
                    <th>Invoice Type</th>
                    <th>Account</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>
                @if (count($purchase_return_invoice_result) > 0)
                    @foreach($purchase_return_invoice_result as $purchase_return)
                        <tr>
                            <td>{{$purchase_return->invoice_no}}</td>
                            <td>Purchase Return Invoice</td>
                            <td>{{$purchase_return->account->name_of_organisation}}</td>
                            <td>
                                {{-- <div class="btn-group">
                                    <div class="pull-left" style="margin-right: 10px;">
                                        <a href="/transactions/purchase-return-vouchers/{{ $purchase_return->id }}/view" class="btn btn-primary">
                                            <i class="fa fa-eye" aria-hidden="true"></i>
                                            View
                                        </a>
                                    </div>
                                    <div class="pull-left" style="margin-right: 10px;">
                                        <a href="/transactions/purchase-return-vouchers/{{ $purchase_return->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                                    </div>
                                    <div class="pull-right">
                                        <form  method="post" action="/transactions/purchase-return-vouchers/{{ $purchase_return->id }}/softdelete">
                                            {{ csrf_field() }}
                                            {{ method_field('DELETE') }}
                                            <button type="submit" class="btn btn-primary">
                                                <i class="fa fa-trash" aria-hidden="true"></i>
                                                Cancel</button>
                                        </form>
                                    </div>
                                </div> --}}
                                @if ($purchase_return->deleted_at != "")
                                    <button type="button" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancelled</button>
                                @else
                                    <div class="btn-group">
                                        @can('view-print-debit-note-purchase-return-voucher')
                                        <div class="pull-left" style="margin-right: 10px;">
                                            <a href="/transactions/purchase-return-vouchers/{{ $purchase_return->id }}/view" class="btn btn-primary"><i class="fa fa-eye" aria-hidden="true"></i> View</a>
                                        </div>
                                        @endcan
                                        @can('edit-debit-note-purchase-return-voucher')
                                        <div class="pull-left" style="margin-right: 10px;">
                                            <a href="/transactions/purchase-return-vouchers/{{ $purchase_return->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                                        </div>
                                        @endcan

                                        @can('cancel-debit-note-purchase-return-voucher')
                                        <div class="pull-left" style="margin-right: 10px;">
                                            <form  method="post" action="/transactions/purchase-return-vouchers/{{ $purchase_return->id }}/softdelete">
                                                {{ csrf_field() }}
                                                {{ method_field('DELETE') }}
                                                <button type="submit" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancel</button>
                                            </form>
                                        </div>
                                        @endcan
                                        @if ($purchase_return->is_signed == 1)
                                            <div class="pull-right" style="margin-right: 10px;">
                                                <a href="/public/user_files/img/client_signs/{{$purchase_return->signature_path}}" target="blank" type="button" class="btn btn-primary"><i class="fa fa-check"></i> Signed</a>
                                            </div>
                                        @else
                                            <div class="pull-right" style="margin-right: 10px;">
                                                <a href="/transactions/purchase-return-vouchers/signature/{{ $purchase_return->id }}/create" type="button" class="btn btn-primary"><i class="fa fa-file-text"></i> Signature</a>
                                            </div>
                                        @endif
                                    </div>
                                @endif
                            </td>
                        </tr>
                    @endforeach
                @else
                    <td colspan="4">No Results Found</td>
                @endif
            </tbody>
        </table>

        {{-- DepositAndWithdrawResult --}}
        <table class="table table-striped table-bordered table-hover dt-responsive" style="margin-bottom: 50px;">
            <thead>
                <tr>
                    <th colspan="4" style="text-align: center">Results In Deposit Withdraw Voucher</th>
                </tr>
                <tr>
                    <th>Invoice Number</th>
                    <th>Invoice Type</th>
                    <th>Amount</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>
                @if (count($deposit_and_withdraw) > 0)
                    @foreach($deposit_and_withdraw as $deposit_withdraw)
                        <tr>
                            <td>{{$deposit_withdraw->invoice_no}}</td>
                            <td>Deposit Withdraw Voucher</td>
                            <td>{{$deposit_withdraw->total_amount}}</td>
                            <td>
                                {{-- <div class="btn-group">
                                    <div class="pull-left" style="margin-right: 10px;">
                                        <a href="/transactions/deposit-withdraw-vouchers/{{ $deposit_withdraw->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                                    </div>
                                    <div class="pull-right">
                                        <form  method="post" action="/transactions/deposit-withdraw-vouchers/{{ $deposit_withdraw->id }}/softdelete">
                                            {{ csrf_field() }}
                                            {{ method_field('DELETE') }}
                                            <button type="submit" class="btn btn-primary">
                                                <i class="fa fa-trash" aria-hidden="true"></i>
                                                Cancel</button>
                                        </form>
                                    </div>
                                </div> --}}
                                @if ($deposit_withdraw->deleted_at != "")
                                    <button type="button" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancelled</button>
                                @else
                                    <div class="btn-group">
                                        @can('edit-deposit-and-withdraw')
                                        <div class="pull-left" style="margin-right: 10px;">
                                            <a href="/transactions/deposit-withdraw-vouchers/{{ $deposit_withdraw->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                                        </div>
                                        @endcan

                                        @can('cancel-deposit-and-withdraw')
                                        <div class="pull-right">
                                            <form  method="post" action="/transactions/deposit-withdraw-vouchers/{{ $deposit_withdraw->id }}/softdelete">
                                                {{ csrf_field() }}
                                                {{ method_field('DELETE') }}
                                                <button type="submit" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancel</button>
                                            </form>
                                        </div>
                                        @endcan
                                    </div>
                                @endif
                            </td>
                        </tr>
                    @endforeach
                @else
                    <td colspan="4">No Result Found</td>
                @endif
            </tbody>
        </table>

        {{-- WareHouseStockTransferResult --}}
        <table class="table table-striped table-bordered table-hover dt-responsive" style="margin-bottom: 50px;">
            <thead>
                <tr>
                    <th colspan="4" style="text-align: center">Results In Warehouse Stock Transfer</th>
                </tr>
                <tr>
                    <th>WST Number</th>
                    <th>Invoice Type</th>
                    <th>Date</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>
                @if (count($warehouse_stock_transfer_result) > 0)
                    @foreach($warehouse_stock_transfer_result as $stock_transfer)
                        <tr>
                            <td>{{$stock_transfer->invoice_no}}</td>
                            <td>Warehouse Stock Transfer</td>
                            <td>{{$stock_transfer->date}}</td>
                            <td>
                                {{-- <div class="btn-group">
                                    <div class="pull-left" style="margin-right: 10px;">
                                        <a href="/transactions/warehouse-stock-transfers/{{ $stock_transfer->id }}/details" class="btn btn-primary">
                                            <i class="fa fa-eye" aria-hidden="true"></i>
                                            View Details
                                        </a>
                                    </div>
                                    <div class="pull-left" style="margin-right: 10px;">
                                        <a href="/transactions/warehouse-stock-transfers/{{ $stock_transfer->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                                    </div>
                                    <div class="pull-right">
                                        <form  method="post" action="/transactions/warehouse-stock-transfers/{{ $stock_transfer->id }}/softdelete">
                                            {{ csrf_field() }}
                                            {{ method_field('DELETE') }}
                                            <button type="submit" class="btn btn-primary">
                                                <i class="fa fa-trash" aria-hidden="true"></i>
                                                Cancel</button>
                                        </form>
                                    </div>
                                </div> --}}
                                @if ($stock_transfer->deleted_at != "")
                                    <button type="button" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancelled</button>
                                @else
                                    <div class="btn-group">
                                        <div class="pull-left" style="margin-right: 10px;">
                                            <a href="/transactions/warehouse-stock-transfers/{{ $stock_transfer->id }}/details" class="btn btn-primary"><i class="fa fa-eye" aria-hidden="true"></i> View Details</a>
                                        </div>
                                        @can('edit-warehouse-transfer')
                                        <div class="pull-left" style="margin-right: 10px;">
                                            <a href="/transactions/warehouse-stock-transfers/{{ $stock_transfer->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                                        </div>
                                        @endcan

                                        @can('cancel-warehouse-transfer')
                                        <div class="pull-right">
                                            <form  method="post" action="/transactions/warehouse-stock-transfers/{{ $stock_transfer->id }}/softdelete">
                                                {{ csrf_field() }}
                                                {{ method_field('DELETE') }}
                                                <button type="submit" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancel</button>
                                            </form>
                                        </div>
                                        @endcan
                                    </div>
                                @endif
                            </td>
                        </tr>
                    @endforeach
                @else
                    <td colspan="4">No Result Found</td>
                @endif
            </tbody>
        </table>
    </div>

</div>
@endsection

@section('js')
<script>
</script>
@endsection
