@extends('layouts.master_user')
@section('page-title')
Other Account Master
@endsection
@section('css')
<style>
    .top {
        margin-top: 22px;
    }
</style>

@endsection
@section('master')
active
@endsection
@section('account_master')
active
@endsection
@section('other_accounts')
active
@endsection
@section('content')
{{--
@section('page-breadcrumb')
<li>
    <a href="{{url('/')}}">Dashboard</a>
</li>
<li class="active">
    <strong>Other Account Master</strong>
</li>
@endsection--}}

<div class="wrapper wrapper-content animated fadeInRight">
    <div class="ibox float-e-margins">
        {{-- <div class="ibox-title">
            <h5>Add Other Accounts</h5>
            <div class="ibox-tools">
                <a class="collapse-link">
                    <i class="fa fa-chevron-up"></i>
                </a>
            </div>
        </div> --}}
        @include('errors.list')
        <div class="ibox-content">
            <form class="form-horizontal" id="create_form" method="POST" action="/masters/account-masters/other-accounts" enctype="multipart/form-data">
                @csrf
                <div class="form-group">
                    <div class="col-sm-6">
                        <label>Transactions Password </label>
                        <input type="password" class="form-control" id="transactions_password" name="transactions_password" placeholder="Transactions Password" >
                    </div>
                    <div class="col-sm-3">
                        <label>Account Opening Balance</label>
                        <input type="text" class="form-control" id="opening_balance" name="opening_balance" placeholder="Account Opening Balance">
                    </div>
                    <div class="col-sm-3">
                        <label>Debit/Credit</label>
                        <select name="debit_credit" id="debit_credit" class="form-control">
                            <option value="">Select Debit/Credit...</option>
                            <option value="debit">Debit</option>
                            <option value="credit">credit</option>
                        </select>
                    </div>
                </div>
                <div class="form-group">
                    <div class="col-sm-6">
                        <label>Reports Password </label>
                        <input type="password" class="form-control" id="report_password" name="report_password" placeholder="Reports Password" >
                    </div>
                    <div class="col-sm-6">
                        <label for="">Date*</label>
                        <div class="input-group date">
                            <span class="input-group-addon"><i class="fa fa-calendar"></i></span><input type="text"
                                class="form-control" id="date" name="date" value="" >
                        </div>
                    </div>
                </div>
                <div class="form-group">
                    <div class="col-sm-12">
                        <label>Account Name*</label>
                        <input type="text" class="form-control" name="name_of_organisation" id="name_of_organisation" placeholder="Account Name" required>
                    </div>
                </div>
                <div class="form-group">
                    <div class="col-sm-6">
                        <label>Class of Account*</label>
                        <select class="form-control" name="class_of_account_id" required>
                            <option value="">Select Class of Account..</option>
                            @foreach ($class_of_accounts as $class)
                                <option value="{{$class->id}}">{{$class->name}}</option>
                            @endforeach
                        </select>
                    </div>
                    <div class="col-sm-6">
                        <label>Show User*</label>

                        <select class="form-control selectpicker" name="show_user[]" data-actions-box="true" data-show-subtext="true" multiple data-live-search="true">
                            @foreach ($users as $user)
                                <option value="{{$user->users['id']}}">{{$user->users['email']}}</option>
                            @endforeach
                        </select>
                    </div>
                </div>
                <div class="hr-line-dashed"></div>
                <div class="form-group">
                    <div class="col-sm-12">
                        <label for="Description">Description</label>
                        <textarea name="description" class="form-control" id="description" cols="30" rows="5" placeholder="Description"></textarea>
                    </div>
                </div>
                <div class="form-group">
                    <div class="col-sm-12">
                        <button class="btn btn-primary pull-right" type="submit">Add Other Account</button>
                    </div>
                </div>
            </form>
        </div>
    </div>
</div>
@endsection

@section('js')
<script>
    $('#create_form').validate(
        {ignore : ":hidden:not(.selectpicker)"  }
    );

    var opening_balance = $('#opening_balance');
    var select = $('#debit_credit');

    var addOrRemoveRequiredAttribute = function () {
        if (opening_balance.val().length) {
            select.attr('required', true);
        }else {
            select.attr('required', false);
        }
    };
    addOrRemoveRequiredAttribute();
    opening_balance.on('change', addOrRemoveRequiredAttribute);

    $(document).ready(function() {
        $('.input-group.date').datepicker({
            startView: 1,
            todayBtn: "linked",
            keyboardNavigation: false,
            forceParse: false,
            autoclose: true,
            format: "yyyy-mm-dd"
        }).datepicker('setDate',new Date());

        $('#country').select2();
    });
</script>
@endsection
