@extends('layouts.master_user')
@section('page-title')
Group Summary
@endsection
@section('css')
<style>

    .top {
        margin-top: 22px;
    }

    .vcenter {
        margin-top: 30px;
    }

    .move_l {
        margin-right: 10px;

    }

    .display-none {
        display: none;
    }

    .display-min {
        width: 280px;
    }

    th{
        text-align: center;
    }
</style>
@section('reports')
active
@endsection
@section('group-summary')
active
@endsection

@endsection

@section('content')

@section('page-breadcrumb')
{{-- <li>
    <a href="{{url('/')}}">Dashboard</a>
</li>
<li class="active">
    <strong>Class of Account</strong>
</li> --}}
@endsection

<div class="wrapper wrapper-content animated fadeInRight">

    @include('errors.list')

    <div class="ibox float-e-margins">
        <div class="ibox-content">
            <div class="row">
                <div class="col-md-6">
                    <p><strong>Date : </strong><strong>{{\Carbon\Carbon::parse($from_date)->format('d-m-Y')}} to {{\Carbon\Carbon::parse($to_date)->format('d-m-Y')}}</strong></p>
                </div>
            </div>
            <div class="form-group top pull-right">
                {{-- <button class="btn btn-primary" id="printbtn" onclick="window.print()"><i
                    class="fa fa-print"></i> Print </button> --}}
                <a href="/reports/group-summary/pdfview/{{$from_date}}/{{$to_date}}/{{$class_of_account}}" target="_blank" class="btn btn-primary"><i class="fa fa fa-print"> Print </i> & <i class="fa fa-file-pdf-o">  PDF Format</i></a>
                <button class="btn btn-secondary " type="button"><i class="fa fa fa-envelope"></i>&nbsp;&nbsp;Email (PDF
                    Format)</button>
                    {{-- <a href="https://api.whatsapp.com/send?phone=923078566095&text=https://google.com" target="_blank">WA</a> --}}
            </div>
            <table class="table table-bordered table-hover">
                <thead>
                    <tr>
                        <th>Particulars</th>
                        <th>Debit</th>
                        <th>Credit</th>
                    </tr>
                </thead>
                <tbody>
                    {{-- @if (count($accounts) > 0) --}}
                        @foreach ($accounts as $key => $account)
                            @if ($accounts[$key] != "")
                                @if ($accounts[$key]->account_master != "")
                                    @if ( ($accounts[$key]->account_master->date >= $from_date)  && ($accounts[$key]->account_master->date <= $to_date) )
                                        <tr>

                                            <td>{{$accounts[$key]->voucher_type}}# {{$accounts[$key]->voucher_no}}</td>
                                            <td>{{ number_format($accounts[$key]->debit, $decimal, '.', '') }}</td>
                                            <td>{{ number_format($accounts[$key]->credit, $decimal, '.', '') }}</td>
                                        </tr>
                                    @endif
                                @endif
                            @endif

                        @endforeach
                    {{-- @endif --}}

                </tbody>
            </table>
        </div>
    </div>
</div>
@endsection

@section('js')
<script>
    $(document).ready(function() {
        $('.input-group.date').datepicker({
            startView: 1,
            todayBtn: "linked",
            keyboardNavigation: false,
            forceParse: false,
            autoclose: true,
            format: "yyyy-mm-dd"
        }).datepicker('setDate',new Date());
    });

    $(document).ready(function () {
    $("#customer_info_btn").click(function () {
    $("#customer_info").toggle();
    });
});
</script>
@endsection
