<!DOCTYPE html>
<html>
<head>
<style>
table {
  font-family: arial, sans-serif;
  border-collapse: collapse;
  width: 100%;
}

td, th {
  border: 1px solid #dddddd;
  text-align: left;
  padding: 8px;
}

tr:nth-child(even) {
  background-color: #dddddd;
}
</style>
</head>
<body>

<h2>Official Vat Report</h2>
<h4>{{\Carbon\Carbon::parse($from_date)->format('d-m-Y')}} to {{\Carbon\Carbon::parse($to_date)->format('d-m-Y')}}</h4>
<div class="row">
    <div class="col-md-6">
        <table class="table table-bordered">
            <thead>
                <tr>
                    <th colspan="4">VAT Input</th>
                </tr>
            </thead>
            <tbody>
                <tr>
                    <th>Date</th>
                    <th>Voucher Description</th>
                    <th>Company Name</th>
                    <th>VAT Amount</th>

                </tr>
                @php
                    $purchase_invoice_vat = 0;
                    $sale_return_vat = 0;
                @endphp
                @foreach ($sorted_purchase_sale_return_data as $item)
                    <tr>
                        <td><p>{{\Carbon\Carbon::parse($item->date)->format('d-m-Y')}}</p></td>
                        <td><p>{{$item->invoice_type}}# {{$item->invoice_no}}</p></td>
                        <td><p>{{$item->account->name_of_organisation}}</p></td>
                        <td><p>{{ number_format($item->vat_amount, $decimal, '.', '') }}</p></td>
                    </tr>
                    @php
                        $purchase_invoice_vat += $item->vat_amount;
                    @endphp
                @endforeach
            </tbody>
            @php
                $sum_purchase_vat = $purchase_invoice_vat + $sale_return_vat;
                $sum_purchase_vat_decimal = number_format($sum_purchase_vat, $decimal, '.', '');
            @endphp
            <tfoot>
                <tr>
                    <td colspan="3">
                        <p><strong>Total VAT Input: </strong></p>
                    </td>
                    <td><p><strong>{{$sum_purchase_vat_decimal}}</strong></p></td>
                </tr>
            </tfoot>
        </table>
    </div>
    <div class="col-md-6">
        <table class="col-md-6 table table-bordered">
            <thead>
                <tr>
                    <th colspan="4">VAT Output</th>
                </tr>
            </thead>
            <tbody>
                <tr>
                    <th>Date</th>
                    <th>Voucher Description</th>
                    <th>Company Name</th>
                    <th>VAT Amount</th>

                </tr>
                @php
                    $sale_invoice_vat = 0;
                    $purchase_return_vat = 0;
                @endphp
                @foreach ($sorted_sale_purchase_return_data as $item)
                    <tr>
                        <td><p>{{\Carbon\Carbon::parse($item->date)->format('d-m-Y')}}</p></td>
                        <td><p>{{$item->invoice_type}}# {{$item->invoice_no}}</p></td>
                        <td><p>{{$item->account->name_of_organisation}}</p></td>
                        <td><p>{{ number_format($item->vat_amount, $decimal, '.', '') }}</p></td>
                    </tr>
                    @php
                        $sale_invoice_vat += $item->vat_amount;
                    @endphp
                @endforeach
            </tbody>
            @php
                $sum_sale_vat = $sale_invoice_vat + $purchase_return_vat;
                $sum_sale_vat_decimal = number_format($sum_sale_vat, $decimal, '.', '');
            @endphp
            <tfoot>
                <tr>
                    <td colspan="3">
                        <p><strong>Total VAT Output:</strong></p>
                    </td>
                    <td><p><strong>{{$sum_sale_vat_decimal}}</strong></p></td>

                </tr>
            </tfoot>
        </table>
    </div>
</div>
<div class="row">
    <div class="col-sm-3 col-sm-offset-9">
        @php
           $vat_payable_receiveable = $sum_purchase_vat_decimal - $sum_sale_vat_decimal
        @endphp
        <p class="text-right"><strong>
            @if ($vat_payable_receiveable < 0)
                Vat Payable : {{ $vat_payable_receiveable }}
            @else
                Vat Receiveable : {{ $vat_payable_receiveable }}
            @endif
        </strong></p>
    </div>
</div>

</body>
</html>
