<!DOCTYPE html>
<html>
<head>
<style>
table {
  font-family: arial, sans-serif;
  border-collapse: collapse;
  width: 100%;
}

td, th {
  border: 1px solid #dddddd;
  text-align: left;
  padding: 8px;
}

tr:nth-child(even) {
  background-color: #dddddd;
}
</style>
</head>
<body>

<h2>Purchase Report</h2>
<h4>{{\Carbon\Carbon::parse($from_date)->format('d-m-Y')}} to {{\Carbon\Carbon::parse($to_date)->format('d-m-Y')}}</h4>
<table>
  <tr>
    <th>Date</th>
    <th>Particulars</th>
    <th>Voucher Description</th>
    <th>Debit</th>
    <th>Credit</th>
  </tr>
  @foreach ($sorted_data as $item)

                        <tr>
                            <td>{{\Carbon\Carbon::parse($item->date)->format('d-m-Y')}}</td>
                            <td>{{$item->account->name_of_organisation}}</td>
                            <td><p>{{$item->invoice_type}}# {{ $item->invoice_no }}</p></td>
                            @if ($item->invoice_type == "purchase return")
                                <td></td>
                                <td>{{ number_format($item->gross_total - $item->discount, $decimal, '.', '') }}</td>
                            @elseif ($item->invoice_type == "purchase")
                                <td>{{ number_format($item->gross_total - $item->discount, $decimal, '.', '') }}</td>
                                <td></td>
                            @endif
                            {{-- <td></td>
                            <td>{{$item->paid_amount}}</td> --}}
                        </tr>
                    @endforeach
                    <tr>
                        <td colspan="3"><strong>Total Credit</strong></td>
                        <td></td>
                        <td><strong>{{$credit_decimal}}<strong></td>
                    </tr>
                    <tr>
                        <td colspan="3"><strong>Total Debit</strong></td>
                        <td><strong>{{$debit_decimal}}</strong></td>
                        <td></td>
                    </tr>
                    <tr>
                        <td colspan="3"><strong>Total</strong></td>
                        @if ($total_decimal >= 0 )
                            <td><strong>{{$total_decimal}}</strong></td>
                            <td></td>

                        @else
                            <td></td>
                            <td><strong>{{$total_decimal}}</strong></td>

                        @endif

                    </tr>

</table>

</body>
</html>
