@extends('layouts.master_user')
@section('page-title')
Particular Item Query
@endsection
@section('css')
<style>

    .display-none {
        display: none;
    }
    .display-min{
        width:280px;
    }
    th{
        text-align: center;
    }


</style>

@endsection
@section('reports')
active
@endsection
@section('stock-report')
active
@endsection

@section('content')

@section('page-breadcrumb')
{{-- <li>
    <a href="{{url('/')}}">Dashboard</a>
</li>
<li class="active">
    <strong>Ledger Report</strong>
</li> --}}
@endsection

<div class="wrapper wrapper-content animated fadeInRight">

    @include('errors.list')

    <div class="ibox float-e-margins">

        <div class="ibox-content">
            <div class="row">
                <div class="col-sm-6">
                    <p><strong>Item Name :</strong> <strong>{{$item_name->name}}</strong></p>
                </div>
            </div>
            <div class="row m-b-md top">
                <div class="col-sm-3">
                    <p><strong>Date: </strong><strong>{{\Carbon\Carbon::parse($from_date)->format('d-m-Y')}} to {{\Carbon\Carbon::parse($to_date)->format('d-m-Y')}}</strong></p>
                </div>
                <div class="col-sm-9">
                    <div class="form-group pull-right">
                        {{-- <button class="btn btn-primary" id="printbtn" onclick="window.print()"><i
                            class="fa fa-print"></i> Print </button> --}}
                        <a href="/reports/stock-report/pdfview/item/{{$from_date}}/{{$to_date}}/{{$item_name->id}}/{{$show_cost}}" target="_blank" class="btn btn-primary"><i class="fa fa fa-print"> Print </i> & <i class="fa fa-file-pdf-o">  PDF Format</i></a>
                        <button class="btn btn-secondary " type="button"><i class="fa fa fa-envelope"></i>&nbsp;&nbsp;Email (PDF
                            Format)</button>
                            {{-- <button type="button" class="btn" id="customer_info_btn"><i
                                class="fa fa-info"></i></button>
                        <div id="customer_info" class="display-none">
                            <p>Contact Person Name: Test</p>
                            <p>Contact #:1234567</p>
                            <p>WhatsApp:1234567</p>
                            <p>Email:test@gmail.com</p>
                            <p>Address: House# , street#, City, Country</p>
                        </div> --}}
                    </div>
                </div>
            </div>
            <table class="table table-bordered table-hover">
                <thead>
                  <tr>
                    <th>Date</th>
                    <th>Account Name</th>
                    <th>Voucher Description</th>
                    <th colspan="3">Inward</th>
                    <th colspan="3">Outward</th>
                  </tr>
                </thead>
                <tbody>
                    <tr>
                        <th></th>
                        <th></th>
                        <th></th>

                        @if ($show_cost == 1)
                            <th>QTY</th>
                            <th>Rate</th>
                            <th>Net Total</th>
                            <th>QTY</th>
                            <th>Rate</th>
                            <th>Profit</th>
                        @else
                            <th colspan="3">Qty</th>
                            <th colspan="3">Qty</th>
                        @endif

                    </tr>
                    @foreach ($sorted_stockreport_data as $item)
                        <tr>
                            <td>{{ \Carbon\Carbon::parse($item->updated_at)->format('d-m-Y') }}</td>
                            @isset($item->invoice->account)
                                <td>{{$item->invoice->account->name_of_organisation}}</td>
                            @else
                            <td>N/A</td>
                            @endisset
                            @if ($item->invoice_type == 'purchase' && $item->invoice->invoice_no == 0)
                            <td>Opening Inventory</td>
                            @else
                            <td><p><strong>
                                @if ($item->invoice_type == "purchase")
                                    <a href="/transactions/purchase-invoices/{{ $item->invoice->id }}/view">{{$item->invoice_type}}# {{ $item->invoice->invoice_no }}
                                @elseif ($item->invoice_type == "sales")
                                    <a href="/transactions/sales-invoices/{{ $item->invoice->id }}/view">{{$item->invoice_type}}# {{ $item->invoice->invoice_no }}
                                @elseif($item->invoice_type == "sale return" || $item->invoice_type == "purchase return")
                                    {{$item->invoice_type}}# {{ $item->invoice->invoice_no }}
                                @else
                                Stock Transfer
                                @endif
                            </strong></p></td>
                            @endif

                            @if ($show_cost == 1)

                                @if ($item->invoice_type == "purchase" || $item->invoice_type == "sale return" || $item->invoice_type == "stock transfer inward")
                                    <td><strong>{{$item->quantity}}</strong></td>
                                    <td><p><strong>{{ number_format($item->rate_per_quantity, $decimal, '.', '') }}</strong></p></td>
                                    <td><p><strong>{{ number_format($item->rate_per_quantity * $item->quantity, $decimal, '.', '') }}</strong></p></td>
                                    <input type="hidden" name="inward" id="inward" class="inward" value="{{$item->rate_per_quantity * $item->quantity}}">
                                    <td><strong></strong></td>
                                    <td><p><strong></strong></p></td>
                                    <td><p><strong></strong></p></td>
                                @elseif ($item->invoice_type == "sales" || $item->invoice_type == "purchase return" || $item->invoice_type == "stock transfer outward")
                                    <td><strong></strong></td>
                                    <td><p><strong></strong></p></td>
                                    <td><p><strong></strong></p></td>
                                    <td><strong>{{$item->quantity}}</strong></td>
                                    <td><p><strong>{{ number_format($item->rate_per_quantity, $decimal, '.', '') }}</strong></p></td>
                                    @if ($item->invoice_type == "stock transfer outward")
                                        <td><p><strong>0</strong></p></td>
                                        <input type="hidden" name="outward" id="outward" class="outward" value="{{ number_format( $item->rate_per_quantity * $item->quantity, $decimal, '.', '') }}">
                                    @else
                                    <td><p><strong>{{ number_format( ($item->rate_per_quantity * $item->quantity) - ($item->purchase_items->rate_per_quantity * $item->quantity), $decimal, '.', '') }}</strong></p></td>
                                    <input type="hidden" name="outward" id="outward" class="outward" value="{{$item->purchase_items->rate_per_quantity * $item->quantity}}">
                                    @endif
                                @endif
                            @else
                                @if ($item->invoice_type == "purchase" || $item->invoice_type == "sale return"  || $item->invoice_type == "stock transfer inward")
                                    <td colspan="3"><strong>{{$item->quantity}}</strong></td>
                                    <td><p><strong></strong></p></td>
                                @elseif ($item->invoice_type == "sales" || $item->invoice_type == "purchase return" || $item->invoice_type == "stock transfer outward")
                                    <td colspan="3"><strong></strong></td>
                                    <td><strong>{{$item->quantity}}</strong></td>
                                @endif
                            @endif
                        </tr>
                    @endforeach

                </tbody>
              </table>
              <div class="row">
                @php
                    $opening_item_quantity = \App\PurchaseSalesTransferStockTrack::Where('item_name_id', $item_name->id)->Where('updated_at', '>=' , '2000-01-01 00:00:00')->Where('updated_at', '<=' , date('Y-m-d', strtotime('-1 day', strtotime($from_date))).' 23:59:59')->sum('quantity');
                    $opening_item_amount = \App\PurchaseSalesTransferStockTrack::Where('item_name_id', $item_name->id)->Where('updated_at', '>=' , '2000-01-01 00:00:00')->Where('updated_at', '<=' , date('Y-m-d', strtotime('-1 day', strtotime($from_date))).' 23:59:59')->where('quantity', '>', 0)->sum('amount');
                    $current_item_quantity = \App\PurchaseSalesTransferStockTrack::Where('item_name_id', $item_name->id)->Where('updated_at', '>=' , $from_date.' 00:00:00')->Where('updated_at', '<=' , $to_date.' 23:59:59')->sum('quantity');
                    $current_item_amount = \App\PurchaseSalesTransferStockTrack::Where('item_name_id', $item_name->id)->Where('updated_at', '>=' , $from_date.' 00:00:00')->Where('updated_at', '<=' , $to_date.' 23:59:59')->where('quantity', '>', 0)->sum('amount');
                    $total_item_quantity = \App\PurchaseSalesTransferStockTrack::where('item_name_id', $item_name->id)->sum('quantity');
                    $total_item_amount = \App\PurchaseSalesTransferStockTrack::where('item_name_id', $item_name->id)->where('quantity', '>', 0)->sum('amount');
                @endphp
                  <div class="col-sm-2 col-sm-offset-8">
                    <p><strong>Opening Quantity : {{$opening_item_quantity}} {{$item_name->units->unit}}</strong></p>
                    <p><strong>Current Quantity : {{$current_item_quantity}} {{$item_name->units->unit}}</strong></p>
                    <p><strong>Closing Quantity : {{$total_item_quantity}} {{$item_name->units->unit}}</strong></p>
                  </div>
                    @if ($show_cost == 1)
                        <div class="col-sm-2">
                            <p><strong>Opening Total : {{ number_format($opening_item_amount, $decimal, '.', '') }}</strong></p>
                            <p><strong>Current Total : {{ number_format($current_item_amount, $decimal, '.', '') }}</strong></p>
                            <p><strong>Closing Total : {{ number_format($total_item_amount, $decimal, '.', '') }}</strong></p>
                        </div>
                    @endif
                </div>
            <input type="hidden" id="currency_decimal" name="currency_decimal" class="currency_decimal" value="{{$decimal}}">

        </div>
    </div>
</div>
@endsection

@section('js')
<script>

    var deci = $('#currency_decimal').val();
    var outward_sum = 0;
    var inward_sum = 0;
    $('.outward').each(function(){
        outward_sum += parseFloat(this.value);
    });
    $('.inward').each(function(){
        inward_sum += parseFloat(this.value);
    });
    var closing_total = inward_sum - outward_sum;

    closing_total = dec_function(closing_total, deci);

    $('#closing_value').text(closing_total);
    // alert(inward_sum - outward_sum);
    // var inward = $('.inward').val();


    $(document).ready(function() {
        $('.input-group.date').datepicker({
            startView: 1,
            todayBtn: "linked",
            keyboardNavigation: false,
            forceParse: false,
            autoclose: true,
            format: "dd/mm/yyyy"
        }).datepicker('setDate',new Date());
    });
            function showLedgerAccount(){
                var select_status=$('#ledger_account_class_id').val();

                if(select_status=='account'){
                    $('#account_class').show();
                    $('#select').hide();
                }
                else{
                    $('#account_class').hide();
                    $('#select').show();


                }
            }
    $(document).ready(function () {
    $("#customer_info_btn").click(function () {
    $("#customer_info").toggle();
    });
});
</script>
@endsection
