@extends('layouts.master_user')
@section('page-title')
Approval Voucher
@endsection
@section('css')
<style>
    .table-responsive {
        display: block;
        width: 100%;
        overflow-x: auto;
        -webkit-overflow-scrolling: touch;
    }

    .table-responsive>.table-bordered {
        border: 0;
    }
    th{
        text-align: center;
    }
</style>

@endsection
@section('transaction')
active
@endsection
@section('approval-voucher')
active
@endsection
@section('content')

<div class="wrapper wrapper-content animated fadeInRight">

    @include('errors.list')

    <div class="row wrapper white-bg page-heading">
        <div class="col-md-12">
            <a href="/transactions/approval-vouchers/create" class="btn btn-primary pull-right"><i class="fa fa-plus" aria-hidden="true"></i> Create Approval Voucher</a>
        </div>
      @if(count($approval_vouchers) != 0)
        <div class="col-md-12">
            <div class="card strpied-tabled-with-hover" style="padding-top: 20px;">
                <div class="card-body">
                    <div class="table-responsive">
                        <table class="table table-striped table-bordered table-hover dt-responsive" >
                        <thead>
                        <tr>
                            <th>Invoice No</th>
                            <th>Date</th>
                            <th>Account Name</th>
                            <th>Action</th>
                        </tr>
                        </thead>
                        <tbody>
                            @foreach($approval_vouchers as $approval_voucher)
                            <tr>
                                <td>{{ $approval_voucher->invoice_no }}</td>
                                <td>{{ $approval_voucher->date }}</td>
                                <td>{{ $approval_voucher->account->name_of_organisation }}</td>
                                <td>
                                    @can('view-print-approval-voucher')
                                        <div class="pull-left" style="margin-right: 10px;">
                                            <a href="/transactions/approval-vouchers/{{ $approval_voucher->id }}/view" class="btn btn-primary"><i class="fa fa-eye" aria-hidden="true"></i> View</a>
                                        </div>
                                    @endcan
                                    @if ($approval_voucher->deleted_at != "")
                                        <button type="button" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancelled</button>    
                                    @else
                                        <div class="btn-group">
                                            {{-- @can('view-print-approval-voucher')
                                            <div class="pull-left" style="margin-right: 10px;">
                                                <a href="/transactions/approval-vouchers/{{ $approval_voucher->id }}/view" class="btn btn-primary"><i class="fa fa-eye" aria-hidden="true"></i> View</a>
                                            </div>
                                            @endcan --}}
                                            
                                            @can('edit-approval-voucher-delivery-notes')
                                            <div class="pull-left" style="margin-right: 10px;">
                                                <a href="/transactions/approval-vouchers/{{ $approval_voucher->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                                            </div>
                                            @endcan
                                            
                                            @can('cancel-approval-voucher-delivery-notes')
                                            <div class="pull-left" style="margin-right: 10px;">
                                                <form  method="post" action="/transactions/approval-vouchers/{{ $approval_voucher->id }}/softdelete">
                                                    {{ csrf_field() }}
                                                    {{ method_field('DELETE') }}
                                                    <button type="submit" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancel</button>
                                                </form>
                                            </div>
                                            @endcan
                                            @if ($approval_voucher->is_signed == 1)
                                                <div class="pull-right" style="margin-right: 10px;">
                                                    <a href="/user_files/img/client_signs/{{$approval_voucher->signature_path}}" target="blank" type="button" class="btn btn-primary"><i class="fa fa-check"></i> Signed</a>
                                                </div>
                                            @else
                                                <div class="pull-right" style="margin-right: 10px;">
                                                    <a href="/transactions/approval-vouchers/signature/{{ $approval_voucher->id }}/create" type="button" class="btn btn-primary"><i class="fa fa-file-text"></i> Signature</a>
                                                </div>
                                            @endif
                                        </div>
                                    @endif    
                                </td>
                            </tr>
                            @endforeach
                        </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
        @else
            <h4 style="text-align:center;">No Approval Voucher has been created yet.</h4>
        @endif
    </div>
</div>
@endsection

@section('js')
<script>
    $(document).ready(function(){
        $('.dataTables-approval_vouchers').DataTable({
            pageLength: 25,
            dom: '<"html5buttons"B>lTfgitp',
            buttons: [
                { extend: 'copy'},
                {extend: 'csv'},
                {extend: 'excel', title: 'ExampleFile'},
                {extend: 'pdf', title: 'ExampleFile'},

                {extend: 'print',
                 customize: function (win){
                        $(win.document.body).addClass('white-bg');
                        $(win.document.body).css('font-size', '10px');

                        $(win.document.body).find('table')
                                .addClass('compact')
                                .css('font-size', 'inherit');
                }
                }
            ]

        });

    });

</script>
@endsection
